#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

long long fctn=1;
long long antfct[10000007]={1};
int stm[10000007]={0, 1};
int mod=1102024631;

void Eratosten(int n)
{
    for(int i=2; i*i<=n; i++)
    {
        if(stm[i]) continue;
        for(int j=i*i; j<=n; j+=i) stm[j]=i;
    }
}

long long fastpow(long long b, int p)
{
    long long res=1, st=b;
    while(p)
    {
        if(p&1) res=res*st%mod;
        st*=st;
        st%=mod;
        p>>=1;
    }
    return res;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n, m, sum=0;
    cin>>m>>n;
    m%=(mod-1);

    for(int i=1; i<=n; i++) fctn=fctn*i%mod;
    antfct[n]=fastpow(fctn, mod-2);
    for(int i=n-1; i>=0; i--)
    {
        antfct[i]=antfct[i+1]*(i+1)%mod;
    }
    Eratosten(n);
    for(int i=2; i<=n; i++)
    {
        if(!stm[i]) stm[i]=fastpow(i, m);
        else stm[i]=(long long)stm[stm[i]]*stm[i/stm[i]]%mod;
    }

    if(n>m) cout<<0<<endl;
    else
    {
        for(int i=0; i<n; i++)
        {
            long long t=antfct[i]*antfct[n-i]%mod;
            t=t*stm[n-i];
            if(i&1) sum-=t;
            else sum+=t;
            if(sum>1e18 || sum<-1e18) sum%=mod;
        }
        cout<<(sum%mod*fctn%mod+mod)%mod<<endl;
    }
    return 0;

}
