#include<bits/stdc++.h>
#include "gcd5.h"

using namespace std;

pair<long long, long long> calculate_Line(long long x1, long long y1, long long x2, long long y2)
{
    return {(y1-y2)/(x1-x2), y1-x1*(y1-y2)/(x1-x2)};
}

map<long long, long long> mpvypr;

long long ask(long long x)
{
    if(mpvypr.find(x)!=mpvypr.end()) return mpvypr[x];
    long long t=query(x);
    return t;
}

pair<long long, long long> lines[100005];
pair<long long, long long> coord[100005];
pair<long long, long long> val[100005];

bool is_on_Line(long long x1, long long y1, long long id)
{
    return (y1)==(lines[id].first*x1+lines[id].second);
}

bool colln(long long x1, long long y1, long long x2, long long y2, long long x3, long long y3)
{
    return (y3-y2)==(y2-y1);
}

void solve(int n)
{
    long long x1=-1e9, x2=-1e9+1;
    long long y1=query(x1), y2=query(x2);
    lines[0]=calculate_Line(x1, y1, x2, y2);
    coord[0]={x1, x2};
    val[0]={y1, y2};

    if(n==1)
    {
        answer(lines[0].first, lines[0].second);
        return;
    }

    x1=1e9;
    x2=1e9-1;
    y1=query(x1), y2=query(x2);
    lines[1]=calculate_Line(x1, y1, x2, y2);
    coord[1]={x1, x2};
    val[1]={y1, y2};

    long long brans=2;
    stack<pair<long long, long long> > st;
    st.push({0, 1});

    while(brans<n && !st.empty())
    {
        long long L1=st.top().first, L2=st.top().second;
        st.pop();

        long long x1=coord[L1].first, x2=coord[L1].second;
        long long y1=val[L1].first, y2=val[L1].second;
        long long k1=lines[L1].first, n1=lines[L1].second;

        long long x3=coord[L2].first, x4=coord[L2].second;
        long long y3=val[L2].first, y4=val[L2].second;
        long long k2=lines[L2].first, n2=lines[L2].second;

        if(x2==x3-1) continue;
        long long chis=n2-n1, znam=k1-k2;
        double pres_x=(double)chis/znam;
        bool fl=0;

        if(chis%znam)
        {
            fl=1;
            long long le_x=chis/znam, ri_x=chis/znam+1;
            if(chis<0) le_x--, ri_x--;
            long long le_y=query(le_x), ri_y=query(ri_x);
            bool lqvo=is_on_Line(le_x, le_y, L1);
            bool dqsno=is_on_Line(ri_x, ri_y, L2);
            if(lqvo && dqsno) continue;
        }

        ///else
        ///{
            long long mid_x=chis/znam;
            long long mid_y=query(mid_x);
            if(!fl && is_on_Line(mid_x, mid_y, L1)) continue;
            long long prev_x=mid_x-1, prev_y=query(prev_x);
            long long nxt_x=mid_x+1, nxt_y=query(nxt_x);
            bool lqvo=is_on_Line(prev_x, prev_y, L1);
            bool dqsno=is_on_Line(nxt_x, nxt_y, L2);
            ///cout<<lqvo<<dqsno<<endl;
            if(lqvo && dqsno)
            {
                lines[brans]=calculate_Line(prev_x, prev_y, mid_x, mid_y);
                coord[brans]={prev_x, mid_x};
                val[brans]={prev_y, mid_y};
                brans++;
            }
            else if(lqvo && !dqsno)
            {
                lines[brans]=calculate_Line(mid_x, mid_y, nxt_x, nxt_y);
                coord[brans]={mid_x, nxt_x};
                val[brans]={mid_y, nxt_y};
                st.push({brans, L2});
                brans++;
            }
            else if(!lqvo && dqsno)
            {
                lines[brans]=calculate_Line(prev_x, prev_y, mid_x, mid_y);
                coord[brans]={prev_x, mid_x};
                val[brans]={prev_y, mid_y};
                st.push({L1, brans});
                brans++;
            }
            else
            {
                if(nxt_y-mid_y==mid_y-prev_y)
                {
                    lines[brans]=calculate_Line(prev_x, prev_y, mid_x, mid_y);
                    coord[brans]={prev_x, mid_x};
                    val[brans]={prev_y, mid_y};
                    st.push({L1, brans});
                    st.push({brans, L2});
                    brans++;
                }
                else
                {
                    long long poprd_x=prev_x-1, poprd_y=query(poprd_x);
                    long long ponxt_x=nxt_x+1, ponxt_y=query(ponxt_x);
                    /**if(mid_y-prev_y==prev_y-poprd_y)
                    {
                        lines[brans]=calculate_Line(prev_x, prev_y, mid_x, mid_y);
                        coord[brans]={prev_x, mid_x};
                        val[brans]={prev_y, mid_y};
                        st.push({L1, brans});
                        brans++;

                        st.push({brans, L2});

                    }*/
                    lines[brans]=calculate_Line(poprd_x, poprd_y, prev_x, prev_y);
                    coord[brans]={poprd_x, prev_x};
                    val[brans]={poprd_y, prev_y};
                    st.push({L1, brans});
                    brans++;

                    lines[brans]=calculate_Line(nxt_x, nxt_y, ponxt_x, ponxt_y);
                    coord[brans]={nxt_x, ponxt_x};
                    val[brans]={nxt_y, ponxt_y};
                    st.push({brans, L2});
                    brans++;
                }
            }
        ///}
    }
    ///for(int i=0; i<brans; i++) cout<<lines[i].first<<" "<<lines[i].second<<endl;
    if(brans!=n) assert(false);
    for(long long i=0; i<n; i++) answer(lines[i].first, lines[i].second);
}

