#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int par[100005];
long long dist[100005];
vector<pair<int, int> > gr[100005];

void dfs(int v)
{
    int brs=gr[v].size();
    for(int i=0; i<brs; i++)
    {
        int nv=gr[v][i].first;
        if(dist[nv]>0 || nv==par[v]) continue;
        if(dist[nv]!=0) dist[nv]=(long long)gr[v][i].second+dist[v];
        par[nv]=v;
        dfs(nv);
    }
}

long long spest[100005];
long long pref[100005];

void solve()
{
    int n;
    long long sum=0;
    cin>>n;

    memset(dist, -1, sizeof(dist));
    for(int i=1; i<=n; i++) gr[i].resize(0);

    for(int i=0; i<n-1; i++)
    {
        int a, b, l;
        cin>>a>>b>>l;
        gr[a].push_back({b, l});
        gr[b].push_back({a, l});
        sum+=l;
    }
    dist[1]=0;
    int br=0;
    for(int tt=1; tt<=n; tt++)
    {
        for(int i=1; i<=n; i++) if(dist[i]!=0) dist[i]=-1;
        dfs(1);
        int mv=1;
        for(int i=1; i<=n; i++) if(dist[i]>dist[mv]) mv=i;
        spest[tt-1]=dist[mv];
        pref[tt-1]=spest[tt-1];
        if(tt>1) pref[tt-1]+=pref[tt-2];
        if(dist[mv]!=0)
        {
            br++;
        }
        else break;
        while(mv!=1)
        {
            dist[mv]=0;
            mv=par[mv];
        }
    }
    ///for(int i=0; i<br; i++) cout<<spest[i]<<" ";
    ///cout<<endl;

    int q;
    cin>>q;
    for(int i=0; i<q; i++)
    {
        long long P;
        cin>>P;
        if(n==1)
        {
            cout<<0<<endl;
            continue;
        }
        if(P<=spest[br-1])
        {
            cout<<sum+(br-1)*P<<endl;
        }
        else if(P>spest[1]) cout<<2*sum-spest[0]<<endl;
        else
        {
            int le=1, ri=br-1;
            while(ri-le>1)
            {
                int mid=(le+ri)/2;
                if(P>=spest[mid]) ri=mid;
                else le=mid;
            }
            cout<<2*sum-pref[le]+le*P<<endl;
        }
    }
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    int t;
    cin>>t;
    while(t--) solve();
    return 0;
}
