#include<bits/stdc++.h>
#define endl '\n'
#define int long long

using namespace std;

const int MAXN=1e5+5;
const int INF=2e18+5;

int n,q;
int p;
vector<pair<int,int> > adj[MAXN];
long long tmp=0;
long long ans=0;
bool used[MAXN];

void dfs(int v,int par,int parW)
{
    used[v]=1;
    for(auto [u,w]: adj[v])
    {
        if(u==par) continue;
        if(used[u]) continue;
        if(tmp>p) ans+=p;
        else ans+=tmp;
        tmp=0;
        ans+=w;
        dfs(u,v,w);
    }
    tmp+=parW;
}

bool cmp(pair<int,int> a,pair<int,int> b)
{
    return a.second<b.second;
}

void init()
{
    for(int i=0;i<=n;i++) adj[i].clear();
    memset(used,0,sizeof(used));
}

signed main()
{
ios::sync_with_stdio(false);
cin.tie(NULL);
cout.tie(NULL);

int tt;
cin>>tt;
while(tt--)
{
    cin>>n; init();
    for(int i=1;i<n;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        adj[u].push_back({v,w});
        adj[v].push_back({u,w});
    }

    for(int i=1;i<=n;i++)
    {
        sort(adj[i].begin(),adj[i].end(),cmp);
    }

    cin>>q;
    for(int i=0;i<q;i++)
    {
        cin>>p;
        ans=0;
        tmp=0;
        dfs(1,0,0);
        cout<<ans<<endl;
    }
}

return 0;
}
/*
5
1 2 10
2 3 4
2 4 9
1 5 6
*/
