#include <algorithm>
#include <array>
#include <cmath>
#include <iostream>
#include <random>
#include <utility>
#include <vector>
#include "gcd5.h"

typedef long long ll;

struct alo{
  ll a,b;
  };

alo getp(ll x1,ll x2,ll y1,ll y2){
  if(x1<x2){
    ll g;
    g=x2;
    x2=x1;
    x1=g;
    g=y2;
    y2=y1;
    y1=g;
    }

  ll difx=x1-x2;
  ll dify=y1-y2;
  ll a=dify/difx;
  ll b=y1-(x1*a);
  return {a,b};
  }

void solve(int n){
  ll q1,q2;
  q1=query(1e9);
  q2=query((1e9)-1);

  alo p1=getp(1e9,(1e9)-1,q1,q2),test;
  ll lst=(1e9)-1;

  for(ll i=1;i<n;++i){
    ll l=-1e9,mid,r=lst-1;

    while(l<=r){
      mid=(l+r)/2;

      test=getp(mid,lst,query(mid),lst*p1.a+p1.b);
      if(test.a==p1.a && test.b==p1.b){
        lst=mid;
        r=mid-1;
        }
      else {
        l=mid+1;
        }
      }

    answer(p1.a,p1.b);

    q1=query(lst-1);
    q2=query(lst-2);
    p1=getp(lst-1,lst-2,q1,q2);
    lst-=2;
    }

  answer(p1.a,p1.b);
  }



