#include <iostream>
#define endl '\n'
using namespace std;

const int MOD = 1102024631;

int modpow(int a, long long b)
{
    int ret = 1;
    while (b)
    {
        if (b & 1) ret = (1ll * ret * a) % MOD;
        b >>= 1;
        a = (1ll * a * a) % MOD;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    long long m;
    cin >> m >> n;

    int ans = modpow(n, m), tmp = 1;
    for (int i = 1; i < n; ++ i)
    {
        tmp = (1ll * tmp * modpow(i, MOD - 2)) % MOD;
        tmp = (1ll * tmp * (n - i + 1)) % MOD;
        if (i % 2) ans = (ans - (1ll * tmp * modpow(n - i, m)) % MOD + MOD) % MOD;
        else ans = (ans + (1ll * tmp * modpow(n - i, m)) % MOD) % MOD;
    }
    cout << ans << endl;

    return 0;
}
