#include <iostream>
#define endl '\n'
using namespace std;

const long long MOD = 1102024631;

long long modpow(long long a, long long b)
{
    long long ret = 1;
    while (b)
    {
        if (b & 1) ret = (ret * a) % MOD;
        b >>= 1;
        a = (a * a) % MOD;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    int n;
    long long m;
    cin >> m >> n;

    int coeff = 1;
    long long ans = modpow(n, m), tmp = 1;
    for (int i = 1; i < n; ++ i)
    {
        coeff *= -1;
        tmp = (tmp * modpow(i, MOD - 2)) % MOD;
        tmp = (tmp * (n - i + 1)) % MOD;
        ans = (ans + coeff * (tmp * modpow(n - i, m)) % MOD + MOD) % MOD;
    }
    cout << ans << endl;

    return 0;
}
