#include "gcd5.h"
#include "Lgrader.cpp"
#include <iostream>
#include <random>
#include <map>
#define endl '\n'
using namespace std;

const int INF = 1e9;
const int INF2 = 2e9;

mt19937 rg(51933941);

map<int, int> mp;

long long query(int x);
void answer(long long a, long long b);

void solve(int n)
{
    int cnt = 0;
    while (cnt < n)
    {
        int x = rg() % (INF2) - INF;
        long long y1 = query(x), y2 = query(x + 1), y3 = query(x + 2);
        if (y3 - y2 == y2 - y1)
        {
            long long a = y2 - y1;
            if (mp.count(a)) continue;
            answer(a, y1 - a * x);
            mp[a] = a;
            cnt++;
        }
        else
        {
            long long y4 = query(x + 3);
            long long a = y4 - y3;
            if (mp.count(a)) continue;
            answer(a, y3 - a * (x + 2));
            mp[a] = a;
            cnt++;
        }
    }
}
