#include "gcd5.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <random>
#include <map>
#define endl '\n'
using namespace std;

const int INF = 1e9;

map<int, long long> mp;

long long query(int x);
void answer(long long a, long long b);

long long query2(int x)
{
    if (mp.count(x)) return mp[x];
    return mp[x] = query(x);
}

void solve(int n)
{
    long long y1 = query2(-INF);
    long long y2 = query2(-INF + 1);
    long long a = y2 - y1, b = y1 + INF * a;
    answer(a, b);
    n--;
    int l0 = -INF + 2, l, r, mid, r0;
    while (n)
    {
        l = l0;
        r = INF;
        while (l <= r)
        {
            mid = (l + r) / 2;
            if (query2(mid) == 1ll * a * mid + b) l = mid + 1;
            else
            {
                r = mid - 1;
                r0 = mid;
            }
        }
        a = query2(r0 + 1) - query2(r0);
        b = query2(r0) - r0 * a;
        answer(a, b);
        l0 = r0 + 2;
        n--;
    }
}
