#include "gcd5.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <random>
#include <map>
#include <set>
#define endl '\n'
using namespace std;

const int INF = 1e9;

map<int, long long> mp;
set< pair<int, long long> > s;

long long query(int x);
void answer(long long a, long long b);

long long query2(int x)
{
    if (mp.count(x)) return mp[x];
    return mp[x] = query(x);
}

void find_line_at(int x)
{
    long long y1 = query2(x), y2 = query2(x + 1), y3 = query2(x + 2);
    if (y3 - y2 == y2 - y1)
    {
        long long a = y2 - y1;
        ///cout << a << " " << y1 - a * x << endl;
        s.insert({a, y1 - a * x});
    }
    else
    {
        long long y4 = query2(x + 3);
        long long a = y4 - y3;
        ///cout << a << " " << y3 - a * (x + 2) << endl;
        s.insert({a, y3 - a * (x + 2)});
    }
}

void solve(int n)
{
    long long y1 = query2(-INF);
    long long y2 = query2(-INF + 1);
    long long a = y2 - y1, b = y1 + INF * a;
    s.insert({a, b});
    ///cout << a << " " << b << endl;
    n--;

    y1 = query2(INF - 1);
    y2 = query2(INF);
    a = y2 - y1;
    b = y2 - INF * a;
    s.insert({a, b});
    ///cout << a << " " << b << endl;
    n--;

    while (n)
    {
        auto it = s.begin();
        long long a1 = (*it).first, b1 = (*it).second;
        it++;
        long long a2 = (*it).first, b2 = (*it).second;
        long long x0 = (b1 - b2 - 1) / (a2 - a1);
        ///cout << a1 << " " << b1 << " " << a2 << " " << b2 << " " << x0 << " " << query(x0) << endl;
        if (query2(x0) > a1 * x0 + b1)
        {
            find_line_at(x0);
            n--;
        }
        else
        {
            answer(a1, b1);
            s.erase(s.begin());
        }
    }

    for (auto it = s.begin(); it != s.end(); ++ it)
    {
        answer((*it).first, (*it).second);
    }
}
