#include "gcd5.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <random>
#include <cmath>
#include <map>
#include <set>
#define endl '\n'
using namespace std;

const long long INF = 1e9;

int N;
map<int, long long> mp, mp2;
set< pair<long long, long long> > s;

long long query(int x);
void answer(long long a, long long b);

long long query2(int x)
{
    if (mp.count(x)) return mp[x];
    return mp[x] = query(x);
}

void find_line_at(int x)
{
    long long y1 = query2(x - 1), y2 = query2(x), y3 = query2(x + 1);
    if (y3 - y2 == y2 - y1 and !mp2.count(y2 - y1))
    {
        long long a = y2 - y1;
        ///cout << a << " " << y1 - a * x << endl;
        s.insert({a, y2 - a * x});
        answer(a, y2 - a * x);
        mp2[a] = 1;
        N--;
    }
    else
    {
        long long y4 = query2(x + 2);
        if (y4 - y3 == y3 - y2 and !mp2.count(y3 - y2))
        {
            long long a = y3 - y2;
            ///cout << a << " " << y3 - a * (x + 2) << endl;
            s.insert({a, y2 - a * x});
            answer(a, y2 - a * x);
            mp2[a] = 1;
        }
        else
        {
            long long a = y2 - y1;
            ///cout << a << " " << y1 - a * x << endl;
            s.insert({a, y2 - a * x});
            answer(a, y2 - a * x);
            mp2[a] = 1;
        }
    }
}

void solve(int n)
{
    N = n;
    long long y1 = query2(-INF);
    long long y2 = query2(-INF + 1);
    long long a = y2 - y1, b = y1 + INF * a;
    s.insert({a, b});
    mp2[a] = 1;
    answer(a, b);
    ///cout << a << " " << b << endl;
    N--;

    if (n == 1) return;

    y1 = query2(INF - 1);
    y2 = query2(INF);
    a = y2 - y1;
    b = y2 - INF * a;
    s.insert({a, b});
    mp2[a] = 1;
    answer(a, b);
    ///cout << a << " " << b << endl;
    N--;

    while (N)
    {
        auto it = s.begin();
        long long a1 = (*it).first, b1 = (*it).second;
        it++;
        long long a2 = (*it).first, b2 = (*it).second;
        long long x0 = floor(1.0 * (b1 - b2) / (a2 - a1));
        ///cout << a1 << " " << b1 << " " << a2 << " " << b2 << " " << x0 << " " << query(x0) << endl;
        if (query2(x0) > a1 * x0 + b1) find_line_at(x0);
        else s.erase(s.begin());
    }
}
