#include<bits/stdc++.h>

#define MOD 1102024631
#define MAXN 100001
#define int long long

using namespace std;

long long n, m;
int dp[MAXN], comb[2][MAXN], pows[MAXN];

void findComb(int i, int j)
{
    comb[i & 1][j] = (comb[(i - 1) & 1][j - 1] + comb[(i - 1) & 1][j]) % MOD;
    //cout<<i<<" "<<j<<": "<<comb[i & 1][j]<<endl;
}
long long bn(long long a, long long p)
{
    long long aa = a, res = 1;
    for(int i = 0; i < 32; i ++)
    {
        if((p & (1 << i)))
        {
            //cout<<i<<" -> "<<aa<<endl;
            res = (res * aa) % MOD;
        }
        aa = (aa * aa) % MOD;
    }
    return res;
}
void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;
    pows[0] = 1;
    for(int j = 1; j <= m; j ++)
    {
        pows[j] = bn(j, n);
        //cout<<j<<" "<<pows[j]<<endl;
    }
}
void solve()
{
    dp[1] = 1;
    pows[1] = m;
    comb[1][0] = comb[1][1] = 1;
    for(int i = 2; i <= m; i ++)
    {
        dp[i] = (pows[i] - i) % MOD;
        if(dp[i] < 0) dp[i] += MOD;
        comb[i & 1][i] = comb[i & 1][0] = 1;
        comb[i & 1][1] = i;
        for(int j = 2; j < i; j ++)
        {
            findComb(i, j);
            dp[i] -= comb[i & 1][j] * dp[j];
            dp[i] %= MOD;
            if(dp[i] < 0) dp[i] += MOD;
        }
    }
    cout<<dp[m]<<endl;
}
signed main()
{
    //cout<<bn(2, 10)<<endl;
    read();
    if(n < m)
    {
        cout<<0<<endl;
        return 0;
    }
    solve();
    return 0;
}

