#include<bits/stdc++.h>
#include "gcd5.h"

#define INF 20000
#define HALFINF 10000

using namespace std;

struct Line
{
    long long a, b;
    Line(){}
    Line(long long yy1, long long yy2, long long x)
    {
        a = yy2 - yy1;
        b = yy1 - a * x;
        //cout<<yy1<<" "<<a<<" "<<x<<endl;
    }
    long long operator() (long long x)
    {
        return a * x + b;
    }
};
int N;
mt19937 mt(chrono::high_resolution_clock::now().time_since_epoch().count());
vector<Line> lines;

bool check(long long x, long long y)
{
    for(auto l : lines)
    {
        if(l(x) == y) return 0;
    }
    return 1;
}
void tries()
{
    long long xx1 = (int)(mt() % INF - HALFINF);
    //cout<<"query: "<<query((int)xx1)<<" "<<xx1<<endl;
    long long y1 = query((int)xx1);
    if(check(xx1, y1))
    {
        long long xx2 = xx1 + 1;
        long long y2 = query((int)xx2);
        long long d1 = y2 - y1;
        long long xx3 = xx2 + 1;
        long long y3 = query((int)xx3);
        long long d2 = y3 - y2;
        //cout<<xx1<<": "<<y1<<endl;
        //cout<<xx2<<": "<<y2<<endl;
        //cout<<xx3<<": "<<y3<<endl;
        if(d2 == d1)
        {
            lines.push_back(Line(y2, y3, xx2));
        }
        else
        {
            long long xx4 = xx3 + 1;
            long long y4 = query((int)xx4);
            long long d3 = y4 - y3;
            if(check(xx3, y3)) lines.push_back(Line(y3, y4, xx3));
            lines.push_back(Line(y1, y2, xx1));
        }
    }
}
void solve(int n)
{
    N = n;
    while(lines.size() != n)
    {
        tries();
    }
    for(auto l : lines)
    {
        answer(l.a, l.b);
        //cout<<l.a<<" "<<l.b<<endl;
    }
}
/*
2
1 -5
-1 5
*/
