#include<bits/stdc++.h>
#include "gcd5.h"
using namespace std;

const long long inf=1e9;

struct line{
    long long a,b;

    inline friend bool operator == (line fr,line sc){
        return fr.a==sc.a and fr.b==sc.b;
    }

    inline friend bool operator != (line fr,line sc){
        return fr.a!=sc.a or fr.b!=sc.b;
    }
};

line getline(long long a,long long b,long long c,long long d){
    if((b-d)%(a-c)!=0)return {-inf-1,0};

    long long k=(b-d)/(a-c);
    return {k,b-k*a};
}

map<long long,bool> mp;

void calc(long long l,long long r,line from,line to){
    if(!mp[from.a]){
        answer(from.a,from.b);
        mp[from.a]=true;
    }
    if(!mp[to.a]){
        answer(to.a,to.b);
        mp[to.a]=true;
    }

    if(l+3>=r){
        return;
    }

    long long mid=(l+r)/2;
    long long curr=query(mid);

    if(from.a*mid+from.b==curr and to.a*mid+to.b==curr){
        return;
    }

    long long lt=query(mid-1),rt=query(mid+1);
    line s,t;

    if(getline(mid-1,lt,mid,curr) == getline(mid,curr,mid+1,rt)){
        s=t=getline(mid-1,lt,mid,curr);
    }else{
        long long ltt=query(mid-2),rtt=query(mid+2);
        s=getline(mid-2,ltt,mid-1,lt);
        t=getline(mid+1,rt,mid+2,rtt);
    }

    if(s!=from){
        calc(l,mid,from,s);
    }

    if(t!=to){
        calc(mid+1,r,t,to);
    }

    return;
}

void solve(int n) {
    calc(-inf,inf,getline(-inf,query(-inf),-inf+1,query(-inf+1)) , getline(inf-1,query(inf-1),inf,query(inf)));   
}
