#include<bits/stdc++.h>
#define MAXN 400007
using namespace std;

int t,n;
int a,b,q;

int parent[MAXN],id[MAXN],pos[MAXN],out[MAXN];
long long dist[MAXN],P,c[MAXN],sum,org[MAXN],ans;
long long cost[MAXN];
vector< pair<int,long long > > v[MAXN];

int tt,in[MAXN],maxs;
bool dali;

pair<long long,int> tree[4*MAXN];
long long lazy[4*MAXN];

pair<long long,int> combine(pair<long long,int> fr,pair<long long,int> sc){
    if(fr.first>sc.first)return fr;
    return sc;
}

void build(int v,int l,int r){
    if(l==r){
        tree[v].first=dist[pos[l]];
        tree[v].second=l;
        lazy[v]=0;

    }else{
        int tt=(l+r)/2;
        build(2*v,l,tt);
        build(2*v+1,tt+1,r);
        
        tree[v]=combine(tree[2*v],tree[2*v+1]);
        lazy[v]=0;
    }
}

void psh(int v){
    lazy[2*v]+=lazy[v];
    lazy[2*v+1]+=lazy[v];

    tree[2*v].first+=lazy[v];
    tree[2*v+1].first+=lazy[v];

    lazy[v]=0;
}

void update(int v,int l,int r,int ll,int rr,long long val){
    if(ll>rr)return;

    if(l==ll and r==rr){
        tree[v].first+=val;
        lazy[v]+=val;
    }else{
        psh(v);

        int tt=(l+r)/2;
        update(2*v,l,tt,ll,min(tt,rr),val);
        update(2*v+1,tt+1,r,max(tt+1,ll),rr,val);
        
        tree[v]=combine(tree[2*v],tree[2*v+1]);
    }
}

void upgrade(int x){
    if(c[id[x]]==0)return;

    update(1,1,n,in[x],out[x],-c[id[x]]);
    upgrade(parent[x]);
    c[id[x]]=0;
}

void dfs(int x,int p){
    parent[x]=p;

    tt++; in[x]=tt; pos[tt]=x;

    for(int i=0;i<v[x].size();i++){
        if(v[x][i].first==p)continue;

        id[v[x][i].first]=v[x][i].second;
        dist[v[x][i].first]=dist[x]+c[v[x][i].second];

        dfs(v[x][i].first,x);
    }

    out[x]=tt;
}

bool cmp(pair<int,long long> fr,pair<int,long long> sc){
    return fr.second>sc.second;
}

long long pref[MAXN];

void solve(){

    cin>>n;
    for(int i=1;i<=n;i++)v[i].clear();
    ans=sum=0;

    for(int i=1;i<=n-1;i++){
        cin>>a>>b>>c[i];
        v[a].push_back({b,i});
        v[b].push_back({a,i});

        sum+=2*c[i];
        org[i]=c[i];
    }

    tt=0;
    dfs(1,0);

    sort(v[1].begin(),v[1].end(),cmp);
    for(int i=1;i<=v[1].size();i++){
        pref[i]=pref[i-1]+v[1][i-1].second;
    }

    cin>>q;
    for(int i=1;i<=q;i++){
        cin>>P;

        if(v[1].size()==n-1){
            int from=0,to=n-1,mid;
            while(from+1<to){
                mid=(from+to)/2;
                if(v[1][mid].second>=P){
                    from=mid;
                }else{
                    to=mid;
                }
            }

            cout<<ans-pref[from+1]+mid*P<<"\n";

            continue;
        }

        build(1,1,n);

        ans=sum; dali=true;
        for(int f=1;f<=n;f++)c[f]=org[f];

        while(true){
            maxs=pos[tree[1].second];            

            if(tree[1].first<=P and !dali)break;

            ans-=tree[1].first; 
            if(!dali)ans+=P;

            upgrade(maxs);

            dali=false;
        }

        cout<<ans<<"\n";
    }
}

int main(){

    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    cin>>t;
    while(t>0){
        solve();
        t--;
    }

    return 0;
}