#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T&a, const T2& b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T&a, const T2& b ){ return a < b ? a = b, 1 : 0;}
#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) #x << " = " << x << "  "

typedef long long ll;

const int MAX_N = 1e4 + 42;
const int mod = 1102024631;

ll fact[MAX_N];
ll revFact[MAX_N];

ll dp[MAX_N][MAX_N];

ll fastPow( ll a, ll step, ll mod ){
    ll nas = 1;
    ll curr = a;
    while( step ){
        if( step & 1 ) nas = ( nas * curr ) % mod;
        curr = ( curr * curr ) % mod;
        step >>= 1;
    }

    return nas;
}

int main (){

#ifndef LOCAL
std::ios_base::sync_with_stdio(false); std::cin.tie(NULL); std::cout.tine(NULL);
#endif // LOCAL

    cerr << out( fastPow(2, 10, mod ) ) << endl;


    int n, m;
    std::cin >> m >> n;

    int N = n;
    if( m < n ){
        std::cout << 0 << endl;
        return 0;
    }


    fact[1] = 1;
    for( int i=2 ; i <= std::max( n, m ) ; i ++ ){
        fact[i] = ( fact[i-1] * ( i ) ) % mod;
        cerr << out( i ) << out( fact[i] ) << endl;
    }

    revFact[m] = fastPow( fact[m], mod -2 , mod);
    for( int i = m-1 ; i >= 0 ; i-- ){
        revFact[i] = ( revFact[i+1] * ( i + 1 ) ) %mod;
        cerr << out( i ) << out( revFact[i] ) << endl;
    }

    for( int i=1 ; i <= m ; i ++ ) dp[i][1] = revFact[i];

    cerr << out( n ) << out( m ) << endl;
    for( int i=2 ; i <= m ; i++ ){ // sum
        for( int j=2 ; j <= m ; j++ ){ // num pocemons

            cerr << out( i ) << out( j ) << endl;
            for( int k=1 ; k <= m ; k++ ){ // curr add

                if( i - k <= 0 ) break;

                dp[i][j] += ( ( dp[i-k][ j-1 ] * revFact[k] ) ) % mod;
                cerr << out( k ) << out( dp[i-k][j-1] ) << " * " << out( revFact[k] ) << endl;
            }

            cerr << out( i ) << out( j ) << out( dp[i][j] ) << endl;
        }
    }

    ll nas = ( fact[m] ) % mod;

    cerr << out( fact[m] ) << out( dp[m][n] ) << endl;
    nas = ( nas * dp[m][n] ) % mod;

    std::cout << nas << endl;

    return 0;
}
