#include <iostream>
#include <stack>
#include <set>
#include "gcd5.h"
using namespace std;
const int MAXN = 1e5 + 1;
const long long INF = 1e9;
//int query(int n) {}
//void answer(long long a, long long b){}
void solve(int n) {
    set< pair<long long, long long> > anss;
    long long y1 = query(-INF), y2 = query(-INF + 1);
    stack< pair<pair<long long, long long>, pair<long long, long long>> > lines;
    long long amin = y2 - y1;
    long long bmin = y1 + amin * INF;
    answer(amin, bmin);
    anss.insert({amin, bmin});
    if (n == 1) {
        return;
    }
    y1 = query(INF - 1);
    y2 = query(INF);
    long long amax = y2 - y1;
    long long bmax = y2 - amax * INF;
    lines.push({{amin, bmin}, {amax, bmax}});
    answer(amax, bmax);
    anss.insert({amax, bmax});
    if (n == 2) {
        return;
    }
    int counter = 2;
    while (!lines.empty()) {
        auto it = lines.top();
        lines.pop();
        auto l1 = it.first, l2 = it.second;
        if (l1.first > l2.first) {
            swap(l1, l2);
        }
        long long x = (l2.second - l1.second) / (l1.first - l2.first);
        long long y = query(x);
        long long yy = query(x + 1);
        if (l1.first * x + l1.second == y && l2.first * (x + 1) + l2.second == yy) {
            continue;
        }
        if (l1.first * x + l1.second == y) {
            x = x + 1;
            y = query(x + 1);
            swap(y, yy);
        }
        long long a = yy - y;
        long long b = y - a * x;
        if (anss.count({a, b}) != 0) {
            continue;
        }
        answer(a, b);
        anss.insert({a, b});
        counter++;
        if (counter == n) {
            return;
        }
        lines.push({{a, b}, l1});
        lines.push({{a, b}, l2});
    }
    cout << 1 / 0;
}
//int main() {
//
//    return 0;
//}
