#include <iostream>
#include <algorithm>
using namespace std;
const int MAXN = 1e5 + 1;
const int INF = 1e9 + 7;
long long depth[MAXN];
long long len[MAXN];
long long prefix[MAXN];

void solve() {
    int n;
    cin >> n;
    long long sum = 0;
    prefix[0] = 0;
    for (int i = 1; i < n; i++) {
        int u, v, l;
        cin >> u >> v >> l;
        sum += l;
        len[i] = l;
    }
    sort(len + 1, len + n);
    for (int i = 1; i <= n; i++) {
        prefix[i] = prefix[i - 1] + len[i];
    }

    int q;
    cin >> q;
    while (q --> 0) {
        int p;
        cin >> p;
        int l = 1, r = n - 1;
        while (1) {
            if (l + 1 == r) {
                break;
            }
            int mid = (l + r) / 2;
            if (len[mid] < p) {
                l = mid;
            } else {
                r = mid;
            }
        }
        cout << sum + prefix[l] + p * (n - 2 - l) + len[n - 1] << '\n';
    }
}

int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    int t;
    cin >> t;
    while (t --> 0) {
        solve();
    }
    return 0;
}

