#include "gcd5.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <cmath>
//#include "Lgrader.cpp"
using namespace std;
const int MAXN = 5*1e6+7;
vector<pair<int,long long>> queries;
pair<int,long long> prava(pair<long long,long long> a,pair<long long,long long> b){
    long long k = (a.second - b.second)/(a.first - b.first);
    long long n = (a.second - a.first*k);
    return {k,n};
}
bool check(pair<long long,long long> a,pair<long long,long long> b,pair<long long,long long> c){
    pair<long long,long long> p = prava(a,b);
    if(p.first*c.first + p.second == c.second){
        return true;
    }
    return false;
}
struct line{
    long long k,n;
};
bool el(pair<int,long long> a,pair<int,long long> b){
    return a.first<b.first;
}
void solve(int n) {
    long long x = -1e9;
    long long y,y1,y2,y3;
    line curr;
    for(long long i=x;i<x+3;i++){
        y1 = query(i);
        y2 = query(i+1);
        y3 = query(i+2);
        //cerr<<"tochkite sa:\n";
        //cerr<<i<<" "<<y1<<"\n";
        //cerr<<i+1<<" "<<y2<<"\n";
        //cerr<<i+2<<" "<<y3<<"\n";
        if(check({i,y1},{i+1,y2},{i+2,y3})){
            x=i;
            curr.k = prava({i,y1},{i+1,y2}).first;
            curr.n = prava({i,y1},{i+1,y2}).second;
            break;
        }
    }
    answer(curr.k,curr.n);
    int br=1;
    long long l = x+2,m, r = 1e9;
    y = y3;
    x=x+2;
    long long m1;
    for(long long i=x;i<=r;i+=sqrt(2*1e9)){
        queries.push_back({i,query(i)});
    }
    while(br<n){
        l=0;
        r=queries.size()-1;
        while(l<r-1){
            m = (l+r)/2;
            if(queries[m].first<x){
                l=m;
            }else{
                r=m;
            }
        }
        l++;
        //cout<<" x > "<<queries[l].first<<"\n";
        r = queries.size()-1;
        while(l<r-1){
            m = (l+r)/2;
            m1 = queries[m].first;
            y1= queries[m].second;
            if(curr.k*m1 + curr.n == y1){
                l=m;
            }else{
                r=m;
            }
        }
        //cout<<queries[l].first<<" < x < "<<queries[r].first<<"\n";
        l = x;
        r = queries[r].first;
        while(l<r-1){
            m = (l+r)/2;
            y1 = query(m);
            if(curr.k*m + curr.n == y1){
                l=m;
                x=m;
                y=y1;
                //cout<<"nadqsno za "<<m<<" "<<y1<<"\n";
            }else{
                //cout<<"nalqvo zashoto "<<m<<" "<<y1<<" ne otgovarq\n";
                r=m;
            }
        }
        x = l+1;
        y1 = query(x);
        y2 = query(x+1);
        curr.k = prava({x,y1},{x+1,y2}).first;
        curr.n = prava({x,y1},{x+1,y2}).second;
        br++;
        y=y1;
        //cout<<"vyv x "<<x<<" i y "<<y<<" e ";
        answer(curr.k,curr.n);
        //cout<<"novata prava e "<<curr.k<<"*x + "<<curr.n<<"\n";
    }
}

