#include "gcd5.h"
#include <iostream>
#include <vector>
#include <algorithm>
#include <map>
#include <cmath>
//#include "Lgrader.cpp"
using namespace std;
const int MAXN = 5*1e6+7;
map<int,int> pravi;
int br;
int N;
pair<int,long long> prava(pair<long long,long long> a,pair<long long,long long> b){
    long long k = (a.second - b.second)/(a.first - b.first);
    long long n = (a.second - a.first*k);
    return {k,n};
}
bool check(pair<long long,long long> a,pair<long long,long long> b,pair<long long,long long> c){
    pair<long long,long long> p = prava(a,b);
    if(p.first*c.first + p.second == c.second){
        return true;
    }
    return false;
}
struct line{
    long long k,n;
};
bool el(pair<long long,long long> a,pair<long long,long long> b){
    return a.first<b.first;
}
void nameri(int l,int r,int k,int n){
    //cout<<"namiram brute force "<<l<<" "<<r<<"\n";
    line g;
    g.k=k;
    g.n=n;
    int m;
    long long y,y1,x,y2;
    int r1=r;
    while(l<r1-2){
        r = r1-1;
        while(l<r-1){
            m = (l+r)/2;
            y1 = query(m);
            if(g.k*m + g.n == y1){
                l=m;
                x=m;
                y=y1;
                //cout<<"nadqsno za "<<m<<" "<<y1<<"\n";
            }else{
                //cout<<"nalqvo zashoto "<<m<<" "<<y1<<" ne otgovarq\n";
                r=m;
            }
        }
        x = l+1;
        y1 = query(x);
        y2 = query(x+1);
        g.k = prava({x,y1},{x+1,y2}).first;
        g.n = prava({x,y1},{x+1,y2}).second;
        y=y1;
        if(pravi.find(g.k)==pravi.end()){
            answer(g.k,g.n);
            pravi[g.k]=1;
            br++;
        }
        if(br==N) return;
    }
}
void reshi(int l,int r,int dir){ /// dir = 1, doshli sme ot dqsno, dir = 0 doshli sme ot lqvo
    if(l+5>r) return;
    //cout<<"reshavam "<<l<<" "<<r<<" "<<dir<<"\n";
    int x = (l+r)/2;
    line curr;
    long long y[5];
    y[0] = query(x);
    y[1] = query(x+1);
    y[2] = query(x+2);
    y[3] = query(x+3);
    y[4] = query(x+4);
    for(long long i=x;i<x+3;i++){
        if(check({i,y[i-x]},{i+1,y[i-x+1]},{i+2,y[i-x+2]})){
            curr.k = prava({i,y[i-x]},{i+1,y[i-x+1]}).first;
            curr.n = prava({i,y[i-x]},{i+1,y[i-x+1]}).second;
            x=i;
            break;
        }
    }
    if(pravi.find(curr.k)==pravi.end()){
        answer(curr.k,curr.n);
        pravi[curr.k]=1;
        br++;
        if(r-x<105) nameri(x,r,curr.k,curr.n);
        else reshi(x,r,0);
        reshi(l,x,1);
    }else{
        if(dir==1){
            reshi(l,x,1);
        }else{
            reshi(x,r,0);
        }
    }

}
void solve(int n) {
    N = n;
    long long l = -1e9,m, r = 1e9;
    reshi(l,r,1);
}

