#include<bits/stdc++.h>
using namespace std;
#define MAXN 100'007
#define v1 v[x][q].first
#define v2 v[x][q].second
#define LOG 19
int n;
vector<pair<int,long long>> v[MAXN];
long long rz[MAXN];
long long dylb[MAXN];
int dpt[MAXN];
int lista[MAXN];
int bl[MAXN][20];
int br=0;
void dfs(int x, int par)
{
    bl[x][0]=par;
    for (int q=0;q<v[x].size();q++)
    {
        if (v1==par) continue;
        rz[v1]=rz[x]+v2;
        dpt[v1]=dpt[x]+1;
        dfs(v1,x);
        dylb[x]=max(dylb[x],dylb[v1]+v2);
    }
}
void setSparse()
{
    for (int q=1;q<=LOG;q++)
    {
        for (int w=1;w<=n;w++)
        {
            bl[w][q]=bl[ bl[w][q-1] ][q-1];
        }
    }
}
int lca(int x, int y)
{
    if (dpt[x]>dpt[y]) swap(x,y);
    int dist=dpt[y]-dpt[x];
    for (int q=0;q<=LOG;q++)
    {
        if ((dist>>q)%2==1)
        {
            y=bl[y][q];
        }
    }
    if (y==x) return y;
    for (int q=LOG;q>=0;q--)
    {
        if (bl[x][q]!=bl[y][q])
        {
            x=bl[x][q];
            y=bl[y][q];
        }
    }
    return bl[x][0];
}
long long ans=-1;
void check(long long p)
{
    long long cur=0;
    cur+=rz[lista[0]];
    for (int q=1;q<br;q++)
    {
        int lc=lca(lista[q-1],lista[q]);
        //cout<<lista[q-1]<<" "<<lista[q]<<" "<<lc<<" "<<p<<" "<<rz[lista[q-1]]-rz[lc]<<" "<<rz[ lista[q] ]-rz[lc]<<"\n";
        cur+=min(p,rz[lista[q-1]]-rz[lc]);
        cur+=rz[ lista[q] ]-rz[lc];
    }
    //cout<<cur<<"\n";
    if (ans==-1 || cur<ans) ans=cur;
}
bool cmp(pair<int,long long> &a, pair<int,long long> &b)
{
    return (dylb[a.first]+a.second)<(dylb[b.first]+b.second);
}
void dfs2(int x, int par)
{
    if (x!=1 && v[x].size()==1)
    {
        lista[br]=x;
        br++;
    }
    for (int q=0;q<v[x].size();q++)
    {
        if (v1==par) continue;
        dfs2(v1,x);
    }
}
void solve()
{
    cin>>n;
    for (int q=1;q<=n;q++) v[q].clear();
    for (int q=1;q<n;q++)
    {
        int a,b;
        long long ll;
        cin>>a>>b>>ll;
        v[a].push_back({b,ll});
        v[b].push_back({a,ll});
    }
    rz[1]=0;
    dpt[1]=0;
    dfs(1,-1);
    bl[1][0]=1;
    setSparse();
    br=0;
    for (int q=1;q<=n;q++) sort(v[q].begin(),v[q].end(),cmp);
    dfs2(1,-1);
    /*for (int q=2;q<=n;q++)
    {
        if (v[q].size()>=1)
        {
            lista[br]=q;
            br++;
        }
    }*/
    int qq;
    cin>>qq;
    for (int w=0;w<qq;w++)
    {
        long long p;
        ans=-1;
        cin>>p;
        //sort(lista,lista+br);
        check(p);
        //while (next_permutation(lista,lista+br)) check(p);
        if (n==1) ans=0;
        cout<<ans<<"\n";
    }
}
int main()
{
    //ios_base::sync_with_stdio(false);
    //cin.tie(NULL);
    //cout.tie(NULL);
    int t;
    cin>>t;
    while (t--) solve();
}

