#include "gcd5.h"
#include <iostream>
using namespace std;
const long long inf=1e9;
int pravi, cnt;
pair <long long, long long> find_prava(long long x1) {
    long long x2;
    x2=x1+1;
    long long y1, y2;
    y1=query(x1); y2=query(x2);
    long long k;
    k=(y2-y1)/(x2-x1);
    long long n=y1-x1*k;
    return {k,n};
}
long long findf(long long x, long long k, long long n) {
    return x*k+n;
}
/*
long long find_intersection(pair <long long, long long> p1, pair <long long, long long> p2) {
    long long dk, dn;
    dk=p1.first-p2.first;
    dn=p2.second-p1.second;
    return dn/dk;
}
void lichao(long long l, long long r, pair <long long, long long> cur, bool from) {
    if (cnt==pravi) return;
    long long mid=(l+r)/2;
    long long y=query(mid);
    if (y<=findf(mid,cur.first,cur.second)) {
        if (from==0) lichao(l,mid-1,cur,from);
        else lichao(mid+1,r,cur,from);
        return; 
    }
    auto pr=find_prava(mid);
    long long x=find_intersection(cur,pr);
    if (from==0) lichao(mid,x,pr,from);
}*/
void solve(int n) {
    long long lef=-inf;
    for (int i=1;i<=n;i++) {
        auto cur=find_prava(lef);
        answer(cur.first,cur.second);
        //cout << cur.first << ' ' << cur.second << endl;
        if (i==n) break;
        long long st=(1ll<<31);
        while (st>0) {
            if (lef+st<=inf) {
                if (query(lef+st)==findf(lef+st,cur.first,cur.second)) lef+=st;
            }
            st=(st>>1);
        }
        lef++;
        //cout << lef << endl;
    }
}
