#include "gcd5.h"
#include <iostream>
using namespace std;
const long long inf=1e9;
int pravi, cnt;
pair <long long, long long> find_prava(long long x1, long long y1, long long x2, long long y2) {
    long long k;
    k=(y2-y1)/(x2-x1);
    long long n=y1-x1*k;
    return {k,n};
}
long long findf(long long x, long long k, long long n) {
    return x*k+n;
}
long long find_intersection(pair <long long, long long> p1, pair <long long, long long> p2) {
    long long dk, dn;
    dk=p1.first-p2.first;
    dn=p2.second-p1.second;
    if (dn%dk) {
        if (dn/dk<0) return dn/dk-1;
        return dn/dk;
    }
    return dn/dk;
}
void find_ans(int l, int r, pair <long long, long long> lef, pair <long long, long long> ri) {
    if (l+2>=r || lef.first==ri.first) return;
    //long long mid=find_intersection(lef,ri);
    long long mid=(l+r)/2;
    /*
    if (findf(mid,lef.first,lef.second)==y2) return;*/
    long long y2=query(mid);
    long long y1, y3, x1, x2, x3;
    x1=mid-1; x2=mid; x3=mid+1;
    y1=query(mid-1);
    y3=query(mid+1);
    pair <long long, long long> cur;
    long double k1, k2;
    k1=(double)(y2-y1)/(double)(x2-x1);
    k2=(double)(y3-y2)/(double)(x3-x2);
    //cout << x2-x1 << ' ' << y2-y1 << ' ' << x3-x2 << ' ' << y3-y2 << ' ' << k1 << ' ' << k2 << endl;
    if (k1==k2) {
        cur=find_prava(x1,y1,x2,y2);
        if (cur.first!=lef.first && cur.first!=ri.first) {
            answer(cur.first,cur.second);
            cout << cur.first << ' ' << cur.second << endl;
            cnt++;
        }
        if (cnt==pravi) return;
        find_ans(l,mid-2,lef,cur);
        if (cnt==pravi) return;
        find_ans(mid+2,r,cur,ri);
        return;
    }
    cur=find_prava(x3,y3,x3+1,query(x3+1));
    //cout << cur.first << ' ' << cur.second << endl;
    if (cur.first!=lef.first && cur.first!=ri.first) {
    answer(cur.first,cur.second);
    cnt++;
    }
    if (cnt==pravi) return;
    find_ans(mid+3,r,cur,ri);
    if (cnt==pravi) return;
    cur=find_prava(x1-1,query(x1-1),x1,y1);
    if (cur.first!=lef.first && cur.first!=ri.first) {
    answer(cur.first,cur.second);
    cnt++;
    }
    if (cnt==pravi) return;
    find_ans(l,mid-3,lef,cur);
}
void solve(int n) {
    long long y1, y2;
    y1=query(-inf);
    y2=query(-inf+1);
    auto beg=find_prava(-inf,y1,-inf+1,y2);
    answer(beg.first,beg.second);
    if (n==1) return;
    y1=query(inf-1);
    y2=query(inf);
    auto e=find_prava(inf-1,y1,inf,y2);
    answer(e.first,e.second);
    if (n==2) return;
    cnt=2;
    pravi=n;
    cout << beg.first << ' ' << beg.second << ' ' << e.first << ' ' << e.second << endl;
    find_ans(-inf,inf,beg,e);
}
