#include <iostream>
#include <vector>
using namespace std;
#define endl '\n'
const int MAXN=1e5+10;
const long long llinf=1e18;
vector <pair <int, long long> > v[MAXN];
pair <int, long long> par[MAXN];
long long ans[MAXN];
long long res, maxs;
int maxi, brch;
void find_ch(int x, int p) {
    if (p!=-1 && v[x].size()==1) brch++;
    for (int i=0;i<v[x].size();i++) {
        if (v[x][i].first==p) continue;
        par[v[x][i].first]={x,i};
        find_ch(v[x][i].first,x);
    }
}
void find_best(int x, int p, long long sum) {
    if (sum>maxs) {
        maxs=sum;
        maxi=x;
    }
    for (auto i:v[x]) {
        if (i.first==p) continue;
        find_best(i.first,x,sum+i.second);
    }
}
void update_tree(int x) {
    while (x!=1) {
        v[par[x].first][par[x].second].second=0;
        //cout << par[x].first << ' ' << v[par[x].first][par[x].second].first << endl;
        x=par[x].first;
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, n, q;
    long long a, b, c;
    cin >> t;
    for (int test=0;test<t;test++) {
        cin >> n;
        for (int i=1;i<=n;i++) {
            if (!v[i].empty()) v[i].clear();
        }
        res=0;
        for (int i=0;i<n-1;i++) {
            cin >> a >> b >> c;
            v[a].push_back({b,c});
            v[b].push_back({a,c});
            res+=2ll*c;
        }
        //cout << res << endl;
        brch=0;
        find_ch(1,-1);
        for (int i=0;i<=brch;i++) {
            maxs=0;
            find_best(1,-1,0);
            res-=maxs;
            ans[i]=res;
            update_tree(maxi);
            //cout << ans[i] << ' ' << maxs << ' ' << maxi << endl;
        }
        cin >> q;
        long long p;
        for (int i=0;i<q;i++) {
            cin >> p;
            long long answer=llinf;
            for (long long j=0;j<brch;j++) {
                answer=min(answer,ans[j]+j*p);
            }
            cout << answer << endl;
        }
    }
    return 0;
}