#include <iostream>
#define MAX_N 105000
using namespace std;

const long long mod = 1102024631;
long long table[2][MAX_N];

int n, m;

long long fact(int s)
{
    long long f=1;

    for(int i=2; i<=s; i++)
    {
        f=(f*i)%mod;
    }
    return f;
}

void fill_table(int col)
{
    int pind=(col+1)%2;
    int ind=col%2;


    table[ind][col]=fact(col);

    for(int i=col+1; i<=m; i++)
    {
        table[ind][i]=(((table[ind][i-1]+table[pind][i-1])%mod)*col)%mod;
    }
}

int main()
{
    cin >> m >> n;

    if(m<n)
    {
        cout << 0;
    }

    else
    {
        for(int i=1; i<=n; i++)
        {
            fill_table(i);
        }
        cout << table[n%2][m];
    }




    return 0;
}
