#include <iostream>
#include <vector>
#include <queue>
#define MAX_N 100005
using namespace std;

vector<vector<int>> trees[5];

long long dist[MAX_N];

long long bfs(int ind)
{
    fill_n(dist, MAX_N, 0);
    queue<int> opashka;
    opashka.push(1);
    int k;
    long long maxl=0;

    while(!opashka.empty())
    {
        k=opashka.front();
        opashka.pop();

        for(int i=0; i<trees[ind][k].size(); i++)
        {
            if(trees[ind][k][i]!=1 && dist[trees[ind][k][i]]==0)
            {
                dist[trees[ind][k][i]]=dist[k]+1;
                if(dist[k]+1>maxl)
                {
                    maxl=dist[k]+1;
                }
                opashka.push(trees[ind][k][i]);
            }
        }
    }
    return maxl;
}

int main()
{
    int t;
    cin >> t;
    long long n;
    int a, b, l;
    int q;
    long long p;

    for(int i=0; i<t; i++)
    {
        cin >> n;
        trees[i].resize(n+1);
        for(int j=0; j<n-1; j++)
        {
            cin >> a >> b >> l;
            trees[i][a].push_back(b);
            trees[i][b].push_back(a);
        }
        cin >> q;
        cin >> p;
    }
    

    for(int i=0; i<t; i++)
    {
        cout<< 2*n-2-bfs(i) << endl;
    }




    return 0;
}
