#include <bits/stdc++.h>

#define MAX_N 7003
#define MAX_M 7003

int64_t dp[2][MAX_M];

#define MOD 1102024631

int64_t do_dp(int64_t n, int64_t m) {
	if (n == 0 && m == 0) return 1;
	if (n == 0 || m == 0) return 0;
	
	dp[0][0] = 1;

	int curr = 1;

	for (int i_n = 1; i_n <= n; i_n += 1) {
		dp[curr][i_n] = 1;
		for (int i_m = i_n + 1; i_m <= m; i_m += 1) {
			dp[curr][i_m] = (dp[curr^1][i_m-1] + dp[curr][i_m-1] * i_n) % MOD;
		}
		curr ^= 1;
	}

	return dp[curr^1][m];
}

int64_t fact(int64_t n) {
	int64_t ans = 1;

	for (int i = 2; i <= n; i += 1) {
		ans = (ans * i) % MOD;
	}

	return ans;
}

int main() {
	std::cin.tie(0);
	std::cout.tie(0);
	std::ios::sync_with_stdio(0);
	
	std::cerr << "naqalo\n";

	int64_t n;
	int64_t m;

	std::cin >> m >> n;

	if (n > m) {
		std::cout << 0 << '\n';
	}

	std::cout << (fact(n) * do_dp(n, m)) % MOD << '\n';
}