#include "gcd5.h"
#include<bits/stdc++.h>
using namespace std;
typedef long long ll;
struct point
{
    ll x, y;

    point (ll _x = 0, ll _y = 0)
    {
        x = _x;
        y = _y;
    }
};

const ll inf = 1e9;
struct line
{
    ll k, m;

    line(ll _k = 0, ll _m = 0)
    {
        k = _k;
        m = _m;
    }

    void init_line(point A, point B)
    {
        k = (B.y - A.y) / (B.x - A.x);
        /// k * A.x + m = A.y
        m = A.y - k * A.x;
    }

    ll calc(ll x)
    {
        return k * x + m;
    }
};

bool same_line(line l1, line l2)
{
    if (l1.k == l2.k && l1.m == l2.m)
        return true;
    return false;
}

double intersect(line l1, line l2)
{
    /// l1.k * x + l1.m = l2.k * x + l2.m
    /// (l1.k - l2.k) * x = l2.m - l1.m
    /// x = (l2.m - l1.m) / (l1.k - l2.k)
    return (double)(l2.m - l1.m) / (double)(l1.k - l2.k);
}
int cnt, N;
void  fun(ll lf, ll rf, line leftmost, line rightmost)
{
    if (cnt == N)
        return;
    double supposed_x = intersect(leftmost, rightmost);
    ll x = ceil(supposed_x);
    vector < ll > imp;
    assert(x - 3 >= -inf && x + 3 <= inf);
    ll v1, v2, v3;

    v2 = query(x - 3);
    v3 = query(x - 2);
    for (ll i = x - 3; i <= x + 1; i ++)
    {
        v1 = v2;
        v2 = v3;
        v3 = query(i + 2);
        line cur;
        cur.init_line(point(i, v1), point(i + 1, v2));
        if (cur.calc(i + 2) != v3)
            continue;

        if (same_line(cur, rightmost))
            break;
        if (same_line(cur, leftmost))
            continue;
        cnt ++;
        ///cout << cur.k << " : " << cur.m << endl;
        answer(cur.k, cur.m);
        fun(lf, i + 1, leftmost, cur);
        fun(i + 1, rf, cur, rightmost);
        break;
        ///if (!same_line(cur) && !same_line(cur, rightmost))
    }

}
void solve(int n)
{
    line leftmost, rightmost;
    leftmost.init_line(point(-inf, query(-inf)), point(-inf + 1, query(-inf + 1)));
    rightmost.init_line(point(inf - 1, query(inf - 1)), point(inf, query(inf)));
    answer(leftmost.k, leftmost.m);
    answer(rightmost.k, rightmost.m);
    cnt = 2;
    fun(-inf, inf, leftmost, rightmost);
}
