#include<bits/stdc++.h>
using namespace std;
const int maxn = 1e5 + 10;
int n;
vector<int> v[maxn];
int anslen;
int maxdepth[maxn];
int maxdepthnb[maxn];
int used[maxn];

void speed(){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
}

void read_graph(){
    for (int i = 1; i <= n; ++i)
        v[i].clear();
    cin >> n;
    int from, to, len;
    for (int i = 1; i < n; ++i){
        cin >> from >> to >> len;
        v[from].push_back(to);
        v[to].push_back(from);
        //anslen += len;
    }
    //anslen *= 2;
}

void DFS_init_maxdepth(int ver){
    used[ver] = true;
    for (int i = 0; i < v[ver].size(); ++i){
        int nb = v[ver][i];
        if (!used[nb]){
            DFS_init_maxdepth(nb);
            if (maxdepth[ver] < maxdepth[nb] + 1){
                maxdepth[ver] = maxdepth[nb] + 1;
                maxdepthnb[ver] = nb;
            }
        }
    }
}

void DFS_find_anslen(int ver, int maxdepthadd){
    used[ver] = 1;
    for (int i = 0; i < v[ver].size(); ++i){
        int nb = v[ver][i];
        if (!used[nb]){
            if (nb == maxdepthnb[ver]){
                anslen += maxdepthadd;
                DFS_find_anslen(nb, maxdepthadd);
            }
            else{
                anslen += 2;
                DFS_find_anslen(nb, 2);
            }
        }
    }
}

int main(){
    int Tests;
    cin >> Tests;
    int Queries;
    int price;
    while (Tests){
        --Tests;
        read_graph();
        cin >> Queries;
        while (Queries){
            --Queries;
            cin >> price;
            anslen = 0;
            memset(used, 0, sizeof(used));
            memset(maxdepth, 0, sizeof(maxdepth));
            DFS_init_maxdepth(1);
            memset(used, 0, sizeof(used));
            DFS_find_anslen(1, 1);
            cout << anslen << "\n";
        }
    }
    return 0;
}
/*
1
20
1 2 1
1 6 1
1 8 1
2 3 1
3 4 1
3 7 1
4 5 1
5 17 1
7 18 1
8 9 1
8 10 1
8 11 1
9 12 1
10 13 1
10 15 1
11 14 1
14 16 1
18 19 1
18 20 1
1
1000000000
*/
