#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 100016
using namespace std;

struct Edge
{
    long long e, w, nom;
};


vector<Edge> edges[MAXN];

long long ans;


queue<long long> q;
long long brNiva[MAXN];
long long allNiva=0;
bool used[MAXN];
void findBrNiva()
{
    brNiva[1] = 0;
    used[1] = true;
    q.push(1);
    allNiva = 0;
    while (!q.empty())
    {
        long long curr = q.front();
        q.pop();
        for (auto edge : edges[curr])
        {
            long long next = edge.e;
            if ( used[next] ) continue;
            used[next] = true;
            brNiva[next] = brNiva[curr] + 1;
            if ( brNiva[next] > allNiva ) allNiva = brNiva[next];
            q.push(next);
        }
    }
}

vector<long long> p;
long long pref[MAXN];

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long T;
    cin >> T;


    for (long long h=0; h<T; h++)
    {
        long long n;
        cin >> n;
        memset(brNiva, 0, sizeof(brNiva));
        memset(used, 0, sizeof(used));
        allNiva = 0;
        for (long long i=1; i<=n; i++)
        {
            edges[i].clear();
        }
        p.clear();
        bool flag = true;
        for (long long j=0; j<n-1; j++)
        {
            long long a, b, l;
            cin >> a >> b >> l;
            edges[a].push_back({b, l, j});
            edges[b].push_back({a, l, j});

            if ( b == 1 ) swap(a, b);
            if ( a != 1  ) flag =  false;
            p.push_back(l);
        }
        if ( flag )
        {
            memset(pref, 0, sizeof(pref));
            sort(p.begin(), p.end());

            long long szP = p.size();
            pref[0] = p[0];
            for (long long i=1; i<szP; i++)
            {
                pref[i] = pref[i-1] + p[i];
            }

            long long Q;
            cin >> Q;
            for (long long g=0; g < Q; g++)
            {
                long long P;
                cin >> P;
                long long ans = p[p.size()-1];
                long long ind = -1;
                for (long long k=p.size()-2; k>=0; k--)
                {
                    // cerr << "k=" << k << endl;
                    long long weight = p[k];

                    if ( weight + P < 2 * weight )
                    {
                        // cerr << "ans += (weight + P)" << endl;
                        ans += (weight + P);
                    }
                    else
                    {
                        //cerr << "ind = k;" << endl;
                        ind = k;
                        break;

                    }

                }
                if ( ind != -1)
                {
                    ans += pref[ind]*2;
                }

                cout << ans << endl;
            }
        }
        else
        {
            findBrNiva();
            long long Q;
            cin >> Q;
            for (long long g=0; g < Q; g++)
            {
                long long P;
                cin >> P;

                cout << ((n-1-allNiva)*2 + allNiva) << endl;
            }

        }


    }
}
/**
2
5
1 2 8
1 3 3
1 4 2
1 5 4
3
10
2
6
3
1 2 7
1 3 4
3
1
2
15
---------------

==================
1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100
---------------------
90
100

*/
