#include<iostream>
#include<vector>
using namespace std;

unsigned long long m , n ;
vector<unsigned long long> r1 ;
vector<unsigned long long> r2 ;

unsigned long long f( unsigned long long a )
    {
    unsigned long long fa = 1 ;
    for ( unsigned long long i = 1 ; i <= a ; i++ )
        {
        fa *= i ;
        fa %= 1102024631 ;
        }
    return fa ;
    }

int main()
{
    ios_base::sync_with_stdio(0);
    cin.tie(NULL);cout.tie(NULL);

    cin >> m >> n ;

    if ( m < n ) { cout << "0\n" ; return 0 ; }
    if ( m == n ) { cout << f( m ) << "\n" ; return 0 ; }
    if ( n == 1 ) { cout << "1\n" ; return 0 ; }

    r1.push_back( 0 ) ;
    r2.push_back( 0 ) ;

    for ( unsigned long long i = 1 ; i <= m ; i++ )
        {
        for ( unsigned long long j = 1 ; j <= n ; j++ )
            {
            if ( i < j ) { j = n + 1 ; continue ; }
            if ( j == 1 )
                {
                if ( i == 1 ) r1.push_back( 1 ) ;
                else if ( i == 2 ) r2.push_back( 1 ) ;
                continue ;
                }
            if ( i <= n+1 )
                {
                if ( i % 2 == 1 ) r1.push_back( 0 ) ;
                if ( i % 2 == 0 ) r2.push_back( 0 ) ;
                }
            else
                {
                if ( i % 2 == 1 ) r1[j] = 0 ;
                if ( i % 2 == 0 ) r2[j] = 0 ;
                }
            if ( i == j )
                {
                if ( i % 2 == 1 ) r1[j] = r2[j-1] * i % 1102024631 ;
                else r2[j] = r1[j-1] * i % 1102024631 ;
                continue ;
                }

            if ( i % 2 == 1 )
                {
                cout << r1[j] << "<->" ;
                r1[j] += (j*r2[j]) % 1102024631 ;
                r1[j] %= 1102024631 ;
                r1[j] += (j*r2[j-1]) % 1102024631 ;
                r1[j] %= 1102024631 ;
                cout << r1[j] << "|" << r2[j]*j << "|" << r2[j-1]*j << ":" << j << " " ;
                }
            else
                {
                cout << r2[j] << "<->" ;
                r2[j] += (j*r1[j]) % 1102024631 ;
                r2[j] %= 1102024631 ;
                r2[j] += (j*r1[j-1]) % 1102024631 ;
                r2[j] %= 1102024631 ;
                cout << r2[j] << "|" << r1[j]*j + r1[j-1]*j << ":" << j << " " ;
                }
            }
        }

    if ( m % 2 == 1 ) cout << r1[n] << "\n" ;
    else cout << r2[n] << "\n" ;
    return 0 ;
}

