#include<iostream>
#include<vector>
#define MAXN 100010
using namespace std;
vector<pair<int,int>> edges[MAXN];
int p;
long long max(long long a, long long b)
{
    if(a>b)return a;
    return b;
}
long long min(long long a, long long b)
{
    if(a<b)return a;
    return b;
}
long long calc(int curr, int parent, long long opt)
{
    for(int i=0;i<edges[curr].size();i++)
    {
        int curr2=edges[curr][i].first;
        int w=edges[curr][i].second;
        if(curr2==parent)continue;
        long long res=calc(curr2,curr,w);
        opt+=min(res+p,res+w);
    }
    return opt;
}
int main()
{
    int n,t,q;
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cin>>t;
    for(int z=0;z<t;z++)
    {
        cin>>n;
        for(int i=1;i<=n;i++)edges[i].clear();
        for(int i=1;i<n;i++)
        {
            int u,v,w;
            cin>>u>>v>>w;
            edges[u].push_back({v,w});
            edges[v].push_back({u,w});
        }
        cin>>q;
        for(int i=0;i<q;i++)
        {
            cin>>p;
            long long ans=calc(1,-1,0);
            cout<<ans-p<<"\n";
        }
    }
}