#include<iostream>
#include<algorithm>
#include<vector>
#define endl '\n'
using namespace std;
typedef long long ll;
const ll MAXN = 1e5;
vector < pair<ll, ll> > graf[MAXN];
void resh(){
    int N;
    cin>>N;
    for(int i = 1; i <= N; i ++){
        graf[i].clear();
    }
    for(int i = 0;i < N-1;i ++){
        int a, b, w;
        cin>>a>>b>>w;
        graf[a].push_back({w, b});
        graf[b].push_back({w, a});
    }
    ll Q;
    cin>>Q;
    ll P[MAXN];
    ll minpr = 0;
    ll tax =0;
    int prefix[MAXN];
    sort(graf[1].begin(), graf[1].end());
    prefix[0] = 0;
    for(int i =0;i < N- 1;i ++){
        prefix[i + 1] = prefix[i] + graf[1][i].first;
    }
    for(int i = 0; i < Q; i ++){
        minpr = 0;
        tax = 0;
        cin>>P[i];
        int l = 0, r = N - 2;
        while(l != r - 1){
            int m = (l + r)/2;
            ///cout << graf[1][l].first << " " << graf[1][r].first << " " << graf[1][m].first << endl;
            if(P[i] > graf[1][m].first){
                l = m;
            }else{
                r = m;
            }
        }
        ///cout<<l<<" "<<N<<endl;
        tax = 2*(prefix[l + 1] - prefix[0]) + (prefix[N - 1] - prefix[l + 1]) + P[i]*(N - 1 -(l + 1) - 1);
        ///cout << graf[1][l].first << " " << graf[1][r].first << endl;
        cout<<tax<<endl;
    }
}
int main (){
    ios_base::sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);
    int T;
    cin >> T;
    for(int i = 0; i < T; i ++){
        resh();
    }
    return 0;
}
/**
1
6
1 2 1
1 3 6
1 4 3
1 5 2
1 6 7
1
4
*/
