#include <bits/stdc++.h>

using namespace std;

const int maxn = 7005;
const long long mod = 1102024631;

int n, m;

/*set<vector<int>> s;
vector<int> curr;

void f(int idx)
{
    if (idx == m)
    {
        unordered_set<int> diff;

        for (auto x : curr)
        {
            diff.insert(x);
        }

        if (diff.size() < n)
        {
            return;
        }

        s.insert(curr);
        return;
    }

    for (int i = 1; i <= n; ++i)
    {
        curr.push_back(i);
        f(idx + 1);
        curr.pop_back();
    }
}*/

long long dp[maxn][maxn];
long long pascal[maxn][maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> m >> n;

    pascal[1][0] = 1;
    pascal[1][1] = 1;

    for (int i = 2; i <= m; ++i)
    {
        pascal[i][0] = 1;

        for (int j = 1; j <= m; ++j)
        {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
        }
    }

    dp[0][0] = 1;

    for (int i = 1; i <= n; ++i)
    {
        for (int j = i; j <= m; ++j)
        {
            for (int k = 1; k <= j - i + 1; ++k)
            {
                dp[i][j] += (dp[i - 1][j - k] * pascal[j][k]) % mod;
            }

            dp[i][j] %= mod;
        }
    }

    cout << dp[n][m] << endl;

    /*f(0);

    cout << "slow :: " << s.size() << endl;

    for (auto curr : s)
    {
        for (auto x : curr)
        {
            cout << x << ' ';
        }

        cout << endl;
    }*/

    return 0;
}
