#include <bits/stdc++.h>

using namespace std;

const int maxn = 7005;
const long long mod = 1102024631;

int n, m;

long long dp[maxn][maxn];
long long fact[maxn];
long long pascal[maxn][maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> m >> n;

    pascal[1][0] = 1;
    pascal[1][1] = 1;
    fact[1] = 1;

    for (int i = 2; i <= m; ++i)
    {
        fact[i] = ((1LL * i) * fact[i - 1]) % mod;
        pascal[i][0] = 1;

        for (int j = 1; j <= m; ++j)
        {
            pascal[i][j] = pascal[i - 1][j] + pascal[i - 1][j - 1];
        }
    }

    dp[0][0] = 1;

    for (int i = 1; i <= n; ++i)
    {
        dp[i][i] = fact[i];
        for (int j = i + 1; j <= m; ++j)
        {
            /*for (int k = 1; k <= j - i + 1; ++k)
            {
                dp[i][j] += (dp[i - 1][j - k] * pascal[j][k]) % mod;
            }

            dp[i][j] %= mod;*/

            dp[i][j] = (1LL * j) * dp[i][j - 1] + (pascal[j][i - 1] * dp[i - 1][i - 1]) % mod;
            dp[i][j] %= mod;
        }
    }

    cout << dp[n][m] << endl;

    return 0;
}
