#include "gcd5.h"
#include <bits/stdc++.h>

using namespace std;

const long long bound = 1e6;

void solve(int n)
{
    long long start = -bound;

    for (int i = 1; i <= n; ++i)
    {
        long long x1 = start;
        long long y1 = query(x1);
        long long x2 = start + 1;
        long long y2 = query(x2);
        long long a = (y1 - y2) / (x1 - x2);
        long long b = y1 - a * x1;

        long long l = start + 2;
        long long r = bound;

        while (l <= r)
        {
            long long mid = (l + r) / 2;

            long long curr = query(mid);

            if (a * mid + b == curr)
            {
                l = mid + 1;
            }
            else
            {
                r = mid - 1;
            }
        }

        answer(a, b);
        start = l;
    }
}
