#include "gcd5.h"
#include <bits/stdc++.h>

using namespace std;

const long long bound = 4e8+1e7;
const long long inf = 1e9;

int cnt = 0;
int n;

unordered_map<long long, long long> asked;
set<pair<long long, long long>> isFound;

long long myQuery(long long x)
{
    if (asked.find(x) != asked.end())
    {
        return asked[x];
    }

    return asked[x] = query(x);
}

void dnc(long long l, long long r)
{
    if (l > r || cnt == n)
    {
        return;
    }

    long long mid = (l + r) / 2;

    long long x1 = mid;
    long long y1 = myQuery(x1);
    long long x2 = mid + 1;
    long long y2 = myQuery(x2);

    long long a = (y1 - y2) / (x1 - x2);
    long long b = y1 - x1 * a;

    long long bsl = mid + 2;
    long long bsr = r;

    while (bsl <= bsr)
    {
        long long bsmid = (bsl + bsr) / 2;

        long long val = myQuery(bsmid);

        if (val == a * bsmid + b)
        {
            bsl = bsmid + 1;
        }
        else
        {
            bsr = bsmid - 1;
        }
    }

    long long to = bsr;

    long long x3 = mid - 1;
    long long y3 = myQuery(mid - 1);

    if (a * x3 + b != y3 && to == mid + 1)
    {
        a = (y3 - y1) / (x3 - x1);
        b = y1 - x1 * a;
    }

    bsl = l;
    bsr = mid - 2;

    while (bsl <= bsr)
    {
        long long bsmid = (bsl + bsr) / 2;

        long long val = myQuery(bsmid);

        if (val == a * bsmid + b)
        {
            bsr = bsmid - 1;
        }
        else
        {
            bsl = bsmid + 1;
        }
    }

    int from = bsl;

    if (isFound.find(make_pair(a, b)) != isFound.end())
    {
        dnc(l, from - 1);
        dnc(to + 1, r);
        return;
    }

    ++cnt;
    answer(a, b);
    isFound.insert(make_pair(a, b));

    //cout << a << " " << b << " " << from << " " << to << endl;

    if (cnt == n)
    {
        return;
    }

    dnc(l, from - 1);
    dnc(to + 1, r);
}

void solve(int N)
{
    n = N;
    cnt = 0;
    dnc(-bound, bound);
}
