#include <bits/stdc++.h>

using namespace std;

const int maxn = 100005;

int n, q;

struct Edge
{
    int to, w;
};

vector<Edge> g[maxn];

long long dp1[maxn];
long long dp2[maxn];

int sz = 0;
long long arr[maxn];
long long val[maxn];
long long pref[maxn];
long long suff[maxn];

void dfs(int node, int par)
{
    dp1[node] = dp2[node] = 0;

    if (g[node].size() == 1 && node != 1)
    {
        return;
    }

    for (int i = 0; i < g[node].size(); ++i)
    {
        int to = g[node][i].to;
        int w = g[node][i].w;

        if (to != par)
        {
            dfs(to, node);
            dp1[node] += (2 * w + dp1[to]);
        }
    }

    sz = 0;

    for (int i = 0; i < g[node].size(); ++i)
    {
        int to = g[node][i].to;
        int w = g[node][i].w;

        if (to != par)
        {
            ++sz;
            arr[sz] = 2 * w + dp1[to];
            val[sz] = w + dp2[to];
        }
    }

    pref[0] = 0;

    for (int i = 1; i <= sz; ++i)
    {
        pref[i] = pref[i - 1] + arr[i];
    }

    suff[sz + 1] = 0;

    for (int i = sz; i >= 1; --i)
    {
        suff[i] = suff[i + 1] + arr[i];
    }

    dp2[node] = (1LL << 60);

    for (int i = 1; i <= sz; ++i)
    {
        dp2[node] = min(dp2[node], val[i] + pref[i - 1] + suff[i + 1]);
    }
}

void solve()
{
    cin >> n;

    for (int i = 1; i <= n - 1; ++i)
    {
        int x, y, w;
        cin >> x >> y >> w;

        g[x].push_back({y, w});
        g[y].push_back({x, w});
    }

    dfs(1, -1);

    cin >> q;

    while (q--)
    {
        int x;
        cin >> x;
        cout << dp2[1] << "\n";
    }

    for (int i = 1; i <= n; ++i)
    {
        g[i].clear();
    }
}

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    int t;
    cin >> t;

    while (t--)
    {
        solve();
    }

    return 0;
}
