#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int64_t MOD = 1102024631;
const int64_t MAXN = 1e7+50;
int64_t n, m;

int64_t dp[MAXN];
int64_t comb[MAXN];
int64_t sum[MAXN];

int64_t POW(int64_t base, int64_t k)
{
    int64_t ans = 1;
    while (k)
    {
        if (k&1)
            ans = (ans*base)%MOD;

        base = (base*base)%MOD;
        k >>= 1;
    }

    return ans;
}


int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);

    cin >> n >> m;

    dp[1] = 1;
    comb[1] = m;
    sum[1] = dp[1]*comb[1];
    for (int i = 2; i <= m; i++)
    {
        dp[i] = (POW(i, n) - sum[i-1])%MOD;

        //cout << i << "->" << dp[i] << endl;
        comb[i] = ((comb[i-1] * (m-i+1))/i)%MOD;

        sum[i] = (sum[i-1] + (comb[i]*dp[i])%MOD)%MOD;
        //cout << comb[i]<< " -> " << i << endl;
    }

    cout << dp[m] << endl;
    return 0;
}
