#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int64_t MOD = 1102024631;
const int64_t MAXN = 1e4+50;
int64_t n, m;

int64_t dp[MAXN];
int64_t comb[MAXN][MAXN];
int64_t sum[MAXN];

int64_t POW(int64_t base, int64_t k)
{
    int64_t ans = 1;
    while (k)
    {
        if (k&1)
            ans = (ans*base)%MOD;

        base = (base*base)%MOD;
        k >>= 1;
    }

    return ans;
}


int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);

    cin >> n >> m;

    comb[0][0] = 1;
    for (int i = 1; i <= m; i++)
    {
        comb[i][0] = comb[i][i] = 1;
        for (int j = 1; j < i; j++)
        {
            comb[i][j] = (comb[i-1][j-1] + comb[i-1][j])%MOD;
        }
    }

    dp[1] = 1;
    for (int64_t i = 2; i <= m; i++)
    {
        dp[i] = POW(i, n);
        for (int64_t j = 1; j < i; j++)
        {
            dp[i] = (dp[i] + MOD * MOD - comb[i][j]*dp[j])%MOD;
        }
    }

    cout << dp[m] << endl;
    return 0;
}
