#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int MAXN = 1e5 + 50;

int64_t P, N, Q;
bool used[MAXN];
int64_t parent[MAXN];
int64_t dist_parent[MAXN];
vector <pair <int64_t, int64_t>> graph[MAXN];

int64_t dfs(int64_t curr, int64_t br, int64_t l, int64_t brUsed, bool started)
{
    if (br > N)
        return LLONG_MAX;

    if (used[curr] == false)
        brUsed++;

    used[curr] = true;

    if (brUsed == N)
    {
        //cout << curr << " " << l << endl;
        return l + P*br;
    }

    bool availableNeighbours = 0;

    int64_t ans = LLONG_MAX;


    for (pair <int64_t, int64_t> i : graph[curr])
    {
        if (!used[i.first])
        {
            availableNeighbours = true;
            ans = min(ans, dfs(i.first, br, l + i.second, brUsed, 0));
        }
    }

    if (availableNeighbours == false && curr != 1)
    {
        ans = min(ans, dfs(parent[curr], br, l + dist_parent[curr], brUsed, false));
        for (int i = 1; i <= N; i++)
        {
            if (used[i] == true && started == false)
            {
                ans = min(ans, dfs(i, br+1, l, brUsed, true));
            }
        }
    }


    //used[curr] = false;
    return ans;
}

void solve()
{
    cin >> N;

    for (int i = 0; i < N-1; i++)
    {
        int64_t u, v, w;
        cin >> u >> v >> w;

        graph[u].push_back({v, w});
        graph[v].push_back({u, w});

        parent[v] = u;
        dist_parent[v] = w;
    }

    cin >> Q;

    for (int i = 0; i < Q; i++)
    {
        cin >> P;

        memset(used, false, sizeof(used));
        cout << dfs(1, 0, 0, 0, 1) << endl;
    }
}
int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);


    int T;
    cin >> T;

    while (T--)
    {
        solve();

    }

    return 0;
}
