#include "gcd5.h"
#include <bits/stdc++.h>

using namespace std;

struct Point
{
    long double x,y;
    Point(){};
    Point(long double xi, long double yi)
    {
        x = xi;
        y = yi;
    }
};

long double a,b;

void SolveAns(Point p1, Point p2)
{
    a = (p1.y-p2.y)/(p1.x-p2.x);
    b = p1.y-(a*p1.x);
    answer(a,b);
}

bool check(Point p)
{
    return p.x*a+b==p.y;
}

void solve(int n)
{
    long double last = -1e9;
    Point v1,v2;
    for(int i=1;i<=n;i++)
    {
        v1 = {last,query(last)};
        v2 = {last+1,query(last+1)};

        SolveAns(v1,v2);
        if(i==n) break;

        long double l = last+2;
        long double r = 1e9;
        long long mid;
        while(l<=r)
        {
            mid = (l+r)/2;
            if(check({mid,query(mid)})) l = mid+1;
            else r = mid-1;
        }
        last = r;
    }
}
