#include "gcd5.h"
#include <bits/stdc++.h>

using namespace std;

struct Point
{
    long long x,y;
    Point(){};
    Point(long long xi, long long yi)
    {
        x = xi;
        y = yi;
    }
};

long long a,b;
unordered_map<long long,long long>mymap;

long long Get_query(long long x)
{
    if(mymap.find(x)==mymap.end())
    {
        mymap[x] = 1;
        mymap[x] = query(x);
    }
    return mymap[x];
}

void SolveAns(Point p1, Point p2)
{
    a = (p1.y-p2.y)/(p1.x-p2.x);
    b = p1.y-(a*p1.x);
    answer(a,b);
}

bool check(Point p)
{
    return p.x*a+b==p.y;
}

void solve(int n)
{
    long long last = -1e9;
    Point v1,v2;
    for(int i=1;i<=n;i++)
    {
        v1 = {last,Get_query(last)};
        v2 = {last+1,Get_query(last+1)};

        SolveAns(v1,v2);
        if(i==n) break;

        long long l = last+2;
        long long r = 1e9;
        long long mid;
        while(l<=r)
        {
            mid = (l+r)/2;
            if(check({mid,Get_query(mid)})) l = mid+1;
            else r = mid-1;
        }
        last = r+1;
    }
}
