#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

const int maxn = 1e5+5;

struct edge
{
    long long ver,dist;
    edge(){};
    edge(int vi, long long di)
    {
        ver = vi;
        dist = di;
    }
};

long long t,n,q;
long long p[maxn];

vector<edge>g[maxn];
pair<int,int> sp[maxn];
long long st[maxn];
long long sub[maxn];

long long coin;
long long ans = 0;

void pre()
{
    for(int i=1;i<=n;i++) g[i].clear();
    for(int i=1;i<=n;i++) sub[i] = 0;
}

void dfs(int beg, int par)
{
    for(edge nb:g[beg])
    {
        if(nb.ver!=par)
        {
            dfs(nb.ver,beg);
            sub[beg] = max(sub[beg],sub[nb.ver]+nb.dist);
        }
    }
}


void solve4()
{
    ans = 2*(n-1);
    dfs(1,1);
    ans -= sub[1];
    cout << ans << endl;
}

void read()
{
    cin >> n;
    pre();
    int x,y,d;
    for(int i=1;i<n;i++)
    {
        cin >> x >> y >> d;
        sp[i] = {x,y};
        st[i] = d;
        g[x].push_back({y,d});
        g[y].push_back({x,d});
    }
    cin >> q;
    for(int i=1;i<=q;i++)
    {
        cin >> p[i];
        coin = p[i];
        solve4();
        //solve();
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> t;
    for(int i=1;i<=t;i++) read();
    return 0;
}
