#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

long long fct[10000007]={1};
long long antfct[10000007]={1};
int mod=1102024631;

long long fastpow(long long b, int p)
{
    long long res=1, st=b;
    while(p)
    {
        if(p&1) res=res*st%mod;
        st*=st;
        st%=mod;
        p/=2;
    }
    return res;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    for(int i=1; i<=10000000; i++)
    {
        fct[i]=fct[i-1]*i%mod;
    }
    antfct[10000000]=fastpow(fct[10000000], mod-2);
    for(int i=10000000-1; i>=0; i--)
    {
        antfct[i]=antfct[i+1]*(i+1)%mod;
    }

    long long n, m, sum=0;
    cin>>m>>n;
    m%=(mod-1);
    if(n>m) cout<<0<<endl;
    else
    {
        for(int i=0; i<n; i++)
        {
            long long t=fct[n]*antfct[i]%mod*antfct[n-i]%mod;
            t=t*fastpow(n-i, m)%mod;
            if(i&1) sum-=t;
            else sum+=t;
        }
        cout<<(sum%mod+mod)%mod<<endl;
    }
    return 0;

}
