#include<bits/stdc++.h>
#define endl '\n'

using namespace std;

int fct[10000007]={1};
int antfct[10000007]={1};
int stm[10000007]={0, 1};
int mod=1102024631;
int zadr[10000007]={1, 1};

void Eratosten(int n)
{
    for(int i=2; i*i<=n; i++)
    {
        if(zadr[i]) continue;
        for(int j=i*i; j<=n; j+=i) zadr[j]=i;
    }
}

long long fastpow(long long b, int p)
{
    long long res=1, st=b;
    while(p)
    {
        if(p&1) res=res*st%mod;
        st*=st;
        st%=mod;
        p>>=1;
    }
    return res;
}

int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long n, m, sum=0;
    cin>>m>>n;
    m%=(mod-1);

    for(int i=1; i<=n; i++)
    {
        fct[i]=(long long)fct[i-1]*i%mod;
    }
    antfct[n]=fastpow(fct[n], mod-2);
    for(int i=n-1; i>=0; i--)
    {
        antfct[i]=(long long)antfct[i+1]*(i+1)%mod;
    }
    Eratosten(n);
    if(n<=1500000) {
    for(int i=2; i<=n; i++)
    {
        if(!zadr[i]) stm[i]=fastpow(i, m);
        else stm[i]=(long long)stm[zadr[i]]*stm[i/zadr[i]]%mod;
    }}

    if(n>m) cout<<0<<endl;
    else
    {
        for(int i=0; i<n; i++)
        {
            long long t=(long long)antfct[i]*antfct[n-i]%mod;
            t=t*stm[n-i]%mod;
            if(i&1) sum-=t;
            else sum+=t;
        }
        cout<<(sum%mod*fct[n]%mod+mod)%mod<<endl;
    }
    return 0;

}
