#include<bits/stdc++.h>
#include "gcd5.h"

using namespace std;

pair<long long, long long> calculate_Line(long long x1, long long y1, long long x2, long long y2)
{
    return {(y1-y2)/(x1-x2), y1-x1*((y1-y2)/(x1-x2))};
}

map<long long, long long> mpvypr;

long long ask(long long x)
{
    if(mpvypr.find(x)!=mpvypr.end()) return mpvypr[x];
    /////cout<<x<<endl;
    long long t=query(x);
    ///mpvypr[x]=t;
    return t;
}

pair<long long, long long> lines[100005];
pair<long long, long long> coord[100005];
pair<long long, long long> val[100005];
set<pair<long long, long long> > set1;

bool is_on_Line(long long x1, long long y1, long long id)
{
    return (y1)==(lines[id].first*x1+lines[id].second);
}

bool colln(long long x1, long long y1, long long x2, long long y2, long long x3, long long y3)
{
    return (y3-y2)==(y2-y1);
}

void solve(int n)
{
    long long x1=-1e9, x2=-1e9+1;
    long long y1=ask(x1), y2=ask(x2);
    lines[0]=calculate_Line(x1, y1, x2, y2);
    coord[0]={x1, x2};
    val[0]={y1, y2};

    if(n==1)
    {
        answer(lines[0].first, lines[0].second);
        return;
    }

    x2=1e9;
    x1=1e9-1;
    y1=ask(x1), y2=ask(x2);
    lines[1]=calculate_Line(x1, y1, x2, y2);
    coord[1]={x1, x2};
    val[1]={y1, y2};

    long long brans=2;
    vector<pair<long long, long long> > st(1);
    st[0]={0, 1};

    mt19937 seed(40000);
    while(brans<n && !st.empty())
    {
        int t=seed()%st.size();
        swap(st[t], st[st.size()-1]);
        long long L1=st[st.size()-1].first, L2=st[st.size()-1].second;
        st.resize(st.size()-1);

        long long x1=coord[L1].first, x2=coord[L1].second;
        long long y1=val[L1].first, y2=val[L1].second;
        long long k1=lines[L1].first, n1=lines[L1].second;

        long long x3=coord[L2].first, x4=coord[L2].second;
        long long y3=val[L2].first, y4=val[L2].second;
        long long k2=lines[L2].first, n2=lines[L2].second;

       /// cout<<k1<<" "<<n1<<" "<<k2<<" "<<n2<<endl;

        if(x2==x3-1 || x1==x4-1) continue;
        long long chis=n2-n1, znam=k1-k2;
        double pres_x=(double)chis/znam;
        if(chis%znam)
        {
            long long le_x=chis/znam, ri_x=chis/znam+1;
            if((chis<0 && znam>0) || (znam<0 && chis>0)) le_x--, ri_x--;
            //cout<<le_x<<" "<<ri_x<<endl;
            long long le_y=ask(le_x), ri_y=ask(ri_x);
            bool lqvo=is_on_Line(le_x, le_y, L1);
            bool dqsno=is_on_Line(ri_x, ri_y, L2);
            //cout<<lqvo<<dqsno<<endl;
            if(lqvo && dqsno) continue;
            if(lqvo && !dqsno)
            {
                long long nxt_x=ri_x+1, nxt_y=ask(nxt_x);
                lines[brans]=calculate_Line(ri_x, ri_y, nxt_x, nxt_y);
                if(set1.find(lines[brans])!=set1.end()) continue;
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                coord[brans]={ri_x, nxt_x};
                val[brans]={ri_y, nxt_y};
                st.push_back({brans, L2});

                set1.insert(lines[brans]);
                brans++;
            }
            else if(dqsno && !lqvo)
            {
                long long prev_x=le_x-1, prev_y=ask(prev_x);
                lines[brans]=calculate_Line(prev_x, prev_y, le_x, le_y);
                if(set1.find(lines[brans])!=set1.end()) continue;
                ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                coord[brans]={prev_x, le_x};
                val[brans]={prev_y, le_y};
                st.push_back({L1, brans});
                set1.insert(lines[brans]);
                brans++;

            }
            else
            {
                long long prev_x=le_x-1, prev_y=ask(prev_x);
                if(prev_y-le_y==le_y-ri_y)
                {
                    lines[brans]=calculate_Line(prev_x, prev_y, le_x, le_y);
                    if(set1.find(lines[brans])!=set1.end()) continue;
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                    coord[brans]={prev_x, le_x};
                    val[brans]={prev_y, le_y};
                    st.push_back({L1, brans});
                    st.push_back({brans, L2});
                    set1.insert(lines[brans]);
                    brans++;
                    continue;
                    /**long long ponxt_x=nxt_x+1, ponxt_y=ask(ponxt_x);
                    lines[brans]=calculate_Line(nxt_x, nxt_y, ponxt_x, ponxt_y);
                    coord[brans]={nxt_x, ponxt_x};
                    val[brans]={nxt_y, ponxt_y};
                    st.push_back({brans, L2});
                    set1.insert(lines[brans]);
                    brans++;*/
                }
                long long nxt_x=ri_x+1, nxt_y=ask(nxt_x);
                if(nxt_y-ri_y==ri_y-le_y)
                {
                    lines[brans]=calculate_Line(ri_x, ri_y, nxt_x, nxt_y);
                    if(set1.find(lines[brans])!=set1.end()) continue;
                        ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                    coord[brans]={ri_x, nxt_x};
                    val[brans]={ri_y, nxt_y};
                    st.push_back({brans, L2});

                    set1.insert(lines[brans]);
                    brans++;

                    long long poprev_x=prev_x-1, poprev_y=ask(poprev_x);
                    lines[brans]=calculate_Line(poprev_x, poprev_y, prev_x, prev_y);
                    if(set1.find(lines[brans])!=set1.end()) continue;
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                    coord[brans]={poprev_x, prev_x};
                    val[brans]={poprev_y, prev_y};
                    st.push_back({L1, brans});
                    set1.insert(lines[brans]);
                    brans++;
                }
                else
                {
                    lines[brans]=calculate_Line(prev_x, prev_y, le_x, le_y);
                    if(set1.find(lines[brans])==set1.end()) {
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                    coord[brans]={prev_x, le_x};
                    val[brans]={prev_y, le_y};
                    st.push_back({L1, brans});
                    set1.insert(lines[brans]);
                    brans++;}

                    lines[brans]=calculate_Line(ri_x, ri_y, nxt_x, nxt_y);
                    if(set1.find(lines[brans])!=set1.end()) continue;
                        ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                    coord[brans]={ri_x, nxt_x};
                    val[brans]={ri_y, nxt_y};
                    st.push_back({brans, L2});

                    set1.insert(lines[brans]);
                    brans++;

                }
            }
        }

        else
        {
            long long mid_x=chis/znam;
            long long mid_y=ask(mid_x);
            /////cout<<"koord "<<mid_x<<mid_y<<endl;
            if(is_on_Line(mid_x, mid_y, L1)) continue;
            long long prev_x=mid_x-1, prev_y=ask(prev_x);
            long long nxt_x=mid_x+1, nxt_y=ask(nxt_x);
            bool lqvo=is_on_Line(prev_x, prev_y, L1);
            bool dqsno=is_on_Line(nxt_x, nxt_y, L2);
            ///////cout<<lqvo<<dqsno<<endl;
            if(lqvo && dqsno)
            {
                lines[brans]=calculate_Line(prev_x, prev_y, mid_x, mid_y);
                    if(set1.find(lines[brans])!=set1.end()) continue;
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                coord[brans]={prev_x, mid_x};
                val[brans]={prev_y, mid_y};
                    set1.insert(lines[brans]);
                brans++;
            }
            else if(lqvo && !dqsno)
            {
                lines[brans]=calculate_Line(mid_x, mid_y, nxt_x, nxt_y);
                    if(set1.find(lines[brans])!=set1.end()) continue;
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                coord[brans]={mid_x, nxt_x};
                val[brans]={mid_y, nxt_y};
                st.push_back({brans, L2});
                    set1.insert(lines[brans]);
                brans++;
            }
            else if(!lqvo && dqsno)
            {
                lines[brans]=calculate_Line(prev_x, prev_y, mid_x, mid_y);
                    if(set1.find(lines[brans])!=set1.end()) continue;
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                coord[brans]={prev_x, mid_x};
                val[brans]={prev_y, mid_y};
                st.push_back({L1, brans});
                    set1.insert(lines[brans]);
                brans++;
            }
            else
            {
                if(nxt_y-mid_y==mid_y-prev_y)
                {
                    lines[brans]=calculate_Line(prev_x, prev_y, mid_x, mid_y);
                    if(set1.find(lines[brans])!=set1.end()) continue;
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                    coord[brans]={prev_x, mid_x};
                    val[brans]={prev_y, mid_y};
                    st.push_back({L1, brans});
                    st.push_back({brans, L2});
                    set1.insert(lines[brans]);
                    brans++;
                }
                else
                {
                    long long poprd_x=prev_x-1, poprd_y=ask(poprd_x);
                    long long ponxt_x=nxt_x+1, ponxt_y=ask(ponxt_x);
                    /**if(mid_y-prev_y==prev_y-poprd_y)
                    {
                        lines[brans]=calculate_Line(prev_x, prev_y, mid_x, mid_y);
                        coord[brans]={prev_x, mid_x};
                        val[brans]={prev_y, mid_y};
                        st.push_back({L1, brans});
                        brans++;

                        st.push_back({brans, L2});

                    }*/
                    lines[brans]=calculate_Line(poprd_x, poprd_y, prev_x, prev_y);
                    if(set1.find(lines[brans])==set1.end()){
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                    coord[brans]={poprd_x, prev_x};
                    val[brans]={poprd_y, prev_y};
                    st.push_back({L1, brans});
                    st.push_back({brans, brans+1});
                    set1.insert(lines[brans]);
                    brans++;}

                    lines[brans]=calculate_Line(nxt_x, nxt_y, ponxt_x, ponxt_y);
                    if(set1.find(lines[brans])==set1.end()){
                    ////cout<<lines[brans].first<<" "<<lines[brans].second<<endl;
                    coord[brans]={nxt_x, ponxt_x};
                    val[brans]={nxt_y, ponxt_y};
                    st.push_back({brans, L2});
                    set1.insert(lines[brans]);
                    brans++;}
                }
            }
        }
    }
    ///for(long long i=0;i<brans; i++) //cout<<lines[i].first<<" "<<lines[i].second<<endl;
    for(long long i=0; i<n; i++) answer(lines[i].first, lines[i].second);
}
