#include "gcd5.h"
#include<bits/stdc++.h>
#define fi first
#define se second

using namespace std;

typedef long long ll;

ll L=-1e9;
ll R=1e9;

set<pair<ll,ll> > lines;

void toAns(ll a,ll b)
{
    if(lines.count({a,b})>0) return;
    lines.insert({a,b});
    answer(a,b);
}

bool isOn(pair<ll,ll> p, pair<ll,ll> t)
{
    if(p.se==t.fi*p.fi+t.se) return 1;
    return 0;
}

int intersect(pair<ll,ll> t1,pair<ll,ll> t2)
{
    return (t2.se-t1.se)/(t1.fi-t2.fi);
}

void rec(int l, int r, pair<ll,ll> t1, pair<ll,ll> t2)
{//cout<<l<<" "<<r<<endl;
    if(r-l<2) return;
    if(t1==t2) return;
    int mid=(l+r)/2;
    mid=intersect(t1,t2);
    if(mid==l) mid++;
    if(mid==r) mid--;
    long long y=query(mid);
    /*if(r-l<2)
    {
        long long y1=query(mid+1);
        long long a=y1-y;
        long long b=y-a*mid;
        toAns(a,b);
        return;
    }*/
    if(isOn({mid,y}, t1))
    {
        rec(mid,r,t1,t2);
        return;
    }
    if(isOn({mid,y}, t2))
    {
        rec(l,mid,t1,t2);
        return;
    }



    long long y1=query(mid-1);
    long long y2=query(mid+1);
    ll a1=y-y1;
    ll a2=y2-y;
    if(a1==a2)
    {
        ll b=y-mid*a1;
        toAns(a1,b);
        rec(l,mid-1,t1,{a1,b});
        rec(mid+1,r,{a1,b},t2);
        return;
    }

    ll y0=query(mid-2);
    ll a0=y1-y0;
    if(a0==a1)
    {
        ll b=y-a1*mid;
        toAns(a1,b);
        rec(l,mid-2,t1,{a1,b});
        rec(mid,r,{a1,b},t2);
        return;
    }

    ll b=y-a2*mid;
    toAns(a2,b);
    ll b0=y1-a0*(mid-1);
    toAns(a0,b0);
    rec(l,mid-2,t1,{a0,b0});
    rec(mid+1,r,{a2,b},t2);
    return;
}

void solve(int n)
{
    long long y1=query(L);
    long long y2=query(L+1);
    long long a=y2-y1;
    long long b=y1-L*a;
    toAns(a,b);
    y1=query(R-1);
    y2=query(R);
    ll a1=y2-y1;
    ll b1=y2-R*a1;
    toAns(a1,b1);
    rec(L+2,R-2,{a,b},{a1,b1});
}
