#include<bits/stdc++.h>
#define endl '\n'
#define int long long

using namespace std;

const int MAXN=100005;
const int INF=2e18+5;

int n,q;
int p;
vector<pair<int,int> > adj[MAXN];
long long up=0;
long long ans=0;

void dfs(int v,int par,int parW)
{
    for(auto [u,w]: adj[v])
    {
        if(u==par) continue;
        ans+=w;
        if(up>p)
        {
            ans+=p;
            up=0;
        }
        else
        {
            ans+=up;
            up=0;
        }
        dfs(u,v,w);
    }
    up+=parW;
}

bool cmp(pair<int,int> x,pair<int,int> y)
{
    return x.second<y.second;
}

void init()
{
    for(int i=0;i<MAXN;i++) adj[i].clear();
    ans=0;
    up=0;
}

signed main()
{
//ios::sync_with_stdio(false);
//cin.tie(NULL);
//cout.tie(NULL);

int tt;
cin>>tt;
for(int r=0;r<tt;r++)
{
    cin>>n; init();
    for(int i=1;i<n;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        adj[u].push_back({v,w});
        adj[v].push_back({u,w});
    }

    for(int i=1;i<=n;i++)
    {
        sort(adj[i].begin(),adj[i].end(),cmp);
    }

    cin>>q;
    for(int i=1;i<q;i++)
    {
        p=0;
        cin>>p;
        ans=0;
        up=0;
        dfs(1,-1,0);
        if(n==1) cout<<0<<endl;
        else cout<<ans<<endl;
    }
}

return 0;
}
/*
5
1 2 10
2 3 4
2 4 9
1 5 6
*/
