#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=7e4+6;
const ll mod=1102024631;
ll addmod(ll a,ll b)
{
    return (a+b)%mod;
}
ll mulmod(ll a,ll b)
{
    return (a*b)%mod;
}
ll submod(ll a,ll b)
{
    return (a+mod-b)%mod;
}
ll fastpow(ll x,ll p)
{
    if(p==0)return 1;
    if(p==1)return x;
    ll t=fastpow(x,p/2);
    t*=t;t%=mod;
    if(p%2==1){t*=x;t%=mod;}
    return t;
}
ll divmod(ll a,ll b)
{
    return a*fastpow(b,mod-2);
}
ll dp[MAXN][2];
ll fact(ll n)
{
    ll ret=1;
    for(ll i=2;i<=n;i++){ret*=i;ret%=mod;}
    return ret;
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    dp[1][1]=1;
    int n,m;
    cin>>m>>n;
    if(n>m)
    {
        cout<<0<<endl;
        return 0;
    }
    for(int i=1;i<=m;i++)
    {
        dp[i][1]=1;
    }
    for(int j=2;j<=n;j++)
    {
        for(int i=j;i<=m;i++)
        {
            dp[i][j%2]=addmod(dp[i-1][1-j%2],mulmod(j, dp[i-1][j%2]));
        }
    }
    cout<<mulmod(dp[m][n%2],fact(n))<<endl;
return 0;
}
