#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=2e5+6;
const ll mod=1102024631;
ll addmod(ll a,ll b)
{
    return (a+b)%mod;
}
ll mulmod(ll a,ll b)
{
    return (a*b)%mod;
}
ll submod(ll a,ll b)
{
    return (a+mod-b)%mod;
}
ll fastpow(ll x,ll p)
{
    if(p==0)return 1;
    if(p==1)return x;
    ll t=fastpow(x,p/2);
    t*=t;t%=mod;
    if(p%2==1){t*=x;t%=mod;}
    return t;
}
ll divmod(ll a,ll b)
{
    return a*fastpow(b,mod-2);
}
ll fact[MAXN];
ll rfact[MAXN];
ll dp[500][500];

ll comb(ll n,ll k)
{
    return divmod(fact[n],mulmod(fact[k],fact[n-k]));
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    ll n,m;
    cin>>m>>n;
    fact[1]=1;
    for(ll i=2;i<=m;i++)fact[i]=mulmod(fact[i-1],i);
    for(ll i=1;i<=m;i++)
    {
        rfact[i]=divmod(1,fact[i]);
    }
    ll m1=m-n;
    dp[0][0]=1;
    for(ll i=1;i<=m1;i++)
    {
        for(int c=1;c<=m1;c++)
        {
            for(int j=0;j<i;j++)
            {
                dp[i][c]+=rfact[i-j+1]*dp[j][c-1];
            }
        }
    }
    ll alo=0;
    for(ll c=1;c<=m1;c++)
    {
        //cout<<c<<" "<<dp[m1][c]<<" "<<comb(n,c)<<endl;
        alo=addmod(alo,mulmod(dp[m1][c], comb(n,c)));
    }
    cout<<mulmod(fact[m],alo)<<endl;
    //cout<<mulmod(dp[m%2][n],fact(n))<<endl;
return 0;
}
