#include "gcd5.h"
#include<bits/stdc++.h>
#define ll long long
using namespace std;
const ll RANDQ=2;
const ll INF1=1e9;
struct line
{
    ll a,b;
    ll eval(ll x)
    {
        return a*x+b;
    }
};
void answer(line l)
{
    answer(l.a,l.b);
}
ll cross(line l1,line l2)
{
    return (l2.b-l1.b)/(l1.a-l2.a);
}
line from_polls(ll x1,ll y1,ll x2,ll y2)
{
    ll a=(y1-y2)/(x1-x2);
    ll b=y1-a*x1;
    return {a,b};
}
bool is_line(line l,ll x)
{
    //we know that query(x)=l.eval(x) and query(x+1)=l.eval(x+1)
    if(x-1>=-INF1&&l.eval(x-1)==query(x-1))
    {
        return true;
    }
    if(x+2<=INF1&&l.eval(x+2)==query(x+2))
    {
        return true;
    }
    return false;
}
ll cntfound=0,n1;
void findlines(ll l,ll r, line lb, line rb)
{
    if(cntfound==n1)return;
    if(r-l+1<3)return;
    ll xll = cross(lb, rb), xll1=xll+1;
    ll yll = query(xll), yll1=query(xll1);
    if((yll == lb.eval(xll) || yll == rb.eval(xll))&&(yll1 == lb.eval(xll1) || yll1 == rb.eval(xll1)))
    {
        return;
    }
    else
    {
        line midline = from_polls(xll, yll, xll1, yll1);
        if(is_line(midline,xll))
        {
            answer(midline);
            cntfound++;
            if(cntfound==n1)return;
            findlines(l, xll,lb,midline);
            findlines(xll+1,r,midline,rb);
        }
        else
        {
            midline = from_polls(xll-1, query(xll-1),xll,yll);
            if(midline.a!=lb.a&&is_line(midline,xll-1))
            {
                answer(midline);
                cntfound++;
                if(cntfound==n1)return;
                findlines(l, xll-1,lb,midline);
                findlines(xll,r,midline,rb);
            }
            else
            {
                midline = from_polls(xll1, yll1,xll1+1,query(xll1+1));
                if(midline.a!=rb.a&&is_line(midline,xll1))
                {
                    answer(midline);
                    cntfound++;
                    if(cntfound==n1)return;
                    findlines(l, xll1,lb,midline);
                    findlines(xll1+1,r,midline,rb);
                }
            }
        }
    }
}
void solve(int n) {
    n1=n;
    line leftmost = from_polls(-INF1, query(-INF1), -INF1+1, query(-INF1+1));
    line rightmost = from_polls(INF1, query(INF1), INF1-1, query(INF1-1));
    answer(leftmost);
    cntfound++;
    if(cntfound==n)return;
    answer(rightmost);
    cntfound++;
    if(cntfound==n)return;
    findlines(-INF1+1, INF1-1, leftmost, rightmost);
}
