#include "gcd5.h"
#include<bits/stdc++.h>
#define ll long long
#define y1 sdsdfsd
using namespace std;
const ll RANDQ=2;
const ll INF1=1e9;
struct line
{
    ll a,b;
    ll eval(ll x)
    {
        return a*x+b;
    }
};
void answer(line l)
{
    answer(l.a,l.b);
}
ll cross(line l1,line l2)
{
    return (l2.b-l1.b)/(l1.a-l2.a);
}
line from_points(ll x1,ll y1,ll x2,ll y2)
{
    ll a=(y1-y2)/(x1-x2);
    ll b=y1-a*x1;
    return {a,b};
}
bool is_line(line l,ll x)
{
    //we know that query(x)=l.eval(x) and query(x+1)=l.eval(x+1)
    if(x-1>=-INF1&&l.eval(x-1)==query(x-1))
    {
        return true;
    }
    if(x+2<=INF1&&l.eval(x+2)==query(x+2))
    {
        return true;
    }
    return false;
}
ll cntfound=0,n1;
void findlines(ll l,ll r, line lb, line rb)
{
    if(cntfound==n1)return;
    if(r-l+1<3)return;
    ll x0 = cross(lb, rb), x1=x0+1,x2=x0-1;
    ll y0 = query(x0), y1=query(x1);
    if((y0 == lb.eval(x0) || y0 == rb.eval(x0)) && (y2 == lb.eval(x2) || y2 == rb.eval(x2)) &&(y1 == lb.eval(x1) || y1 == rb.eval(x1)))
    {
        return;
    }
    else
    {
        line midline = from_points(x0, y0, x1, y1);
        if(midline.a!=rb.a&&midline.a!=lb.a&&is_line(midline,x0))
        {
            answer(midline);
            cntfound++;
            if(cntfound==n1)return;
            findlines(l, x0,lb,midline);
            findlines(x0+1,r,midline,rb);
        }
        else
        {
            midline = from_points(x0-1, query(x0-1),x0,y0);
            if(midline.a!=rb.a&&midline.a!=lb.a&&is_line(midline,x0-1))
            {
                answer(midline);
                cntfound++;
                if(cntfound==n1)return;
                findlines(l, x0-1,lb,midline);
                findlines(x0,r,midline,rb);
            }
            else
            {
                midline = from_points(x1, y1,x1+1,query(x1+1));
                if(midline.a!=rb.a&&midline.a!=lb.a&&is_line(midline,x1))
                {
                    answer(midline);
                    cntfound++;
                    if(cntfound==n1)return;
                    findlines(l, x1,lb,midline);
                    findlines(x1+1,r,midline,rb);
                }
                else
                {
                    midline = from_points(x2, y2, x2+1, query(x2+1));
                    if(midline.a!=rb.a&&is_line(midline,x2))
                    {
                        answer(midline);
                        cntfound++;
                        if(cntfound==n1)return;
                        findlines(l, x2,lb,midline);
                        findlines(x2+1,r,midline,rb);
                    }
                }
            }
        }
    }
}
void solve(int n) {
    n1=n;
    line leftmost = from_points(-INF1, query(-INF1), -INF1+1, query(-INF1+1));
    line rightmost = from_points(INF1, query(INF1), INF1-1, query(INF1-1));
    answer(leftmost);
    cntfound++;
    if(cntfound==n)return;
    answer(rightmost);
    cntfound++;
    if(cntfound==n)return;
    findlines(-INF1+1, INF1-1, leftmost, rightmost);
    if(cntfound<n)
    {
        int x = query(3*INF1);
    }
}
