#include<bits/stdc++.h>
using namespace std;
#define ll long long
const ll MAXN=1e5+6;
struct line
{
    ll a,b;
    ll eval(int x)
    {
        return a*x+b;
    }
};
ll cross(line l1,line l2)
{
    return (l2.b-l1.b)/(l1.a-l2.a);
}

int time_in[MAXN];
int time_out[MAXN];
ll arr[MAXN];
int what[MAXN];
vector<pair<int,ll> >g[MAXN];
vector<line>cht;
int t=0,n,q,alo;
int par[MAXN];
vector<ll>ps;
bool mark[MAXN];
ll dep[MAXN];
ll cost[MAXN];
ll sum_all;
ll ans[MAXN];
struct st
{
    pair<ll,int> tree[4*MAXN];
    ll lazy[4*MAXN];
    void push(int l,int r,int idx)
    {
        tree[idx].first+=lazy[idx];
        if(l!=r)
        {
            lazy[idx*2]+=lazy[idx];
            lazy[idx*2+1]+=lazy[idx];
        }
        lazy[idx]=0;
    }
    void build(int l,int r,int idx)
    {
        lazy[idx]=0;
        if(l==r)
        {
            tree[idx]={arr[l],l};
            return;
        }
        int mid=(l+r)/2;
        build(l,mid,idx*2);
        build(mid+1,r,idx*2+1);
        tree[idx]=max(tree[idx*2],tree[idx*2+1]);
    }
    pair<ll,ll> query(int l,int r,int idx,int ql,int qr)
    {
        push(l,r,idx);
        if(l>qr)return {-1,-1};
        if(r<ql)return {-1,-1};
        if(l>=ql&&r<=qr)return tree[idx];
        int mid=(l+r)/2;
        max(query(l,mid,idx*2,ql,qr),query(mid+1,r,idx*2+1,ql,qr));
    }
    void update(int l,int r,int idx,int ql,int qr,ll val)
    {
        push(l,r,idx);
        if(l>qr)return;
        if(r<ql)return;
        if(l>=ql&&r<=qr)
        {
            lazy[idx]+=val;
            push(l,r,idx);
            return;
        }
        int mid=(l+r)/2;
        update(l,mid,idx*2,ql,qr,val);
        update(mid+1,r,idx*2+1,ql,qr,val);
        tree[idx]=max(tree[idx*2],tree[idx*2+1]);
    }
}ogi;
void dfs(int u,int p)
{
    par[u]=p;
    time_in[u]=++t;
    for(auto xd:g[u])
    {
        if(xd.first==p)continue;
        dep[xd.first]=dep[u]+xd.second;
        dfs(xd.first,u);
    }
    time_out[u]=t;
}
void read()
{
    sum_all=0;
    memset(mark,0,sizeof(mark));
    memset(dep,0,sizeof(dep));
    memset(par,0,sizeof(par));
    memset(cost,0,sizeof(cost));
    cin>>n;
    for(int i=1;i<=n;i++)g[i].clear();
    for(int i=1;i<n;i++)
    {
        int u,v,w;
        cin>>u>>v>>w;
        g[u].push_back({v,w});
        g[v].push_back({u,w});
        sum_all+=w;
    }
    cin>>q;
    ps.clear();
    for(int i=0;i<q;i++)
    {
        int x;
        cin>>x;
        ps.push_back(x);
    }
}
void solve_lines()
{
    cht.clear();
    for(int i=1;i<=n-1;i++)
    {
        //cout<<i-1<<" "<<cost[i]<<endl;
        if(cht.size()<2)
        {
            cht.push_back({(i-1), cost[i]});
        }
        else
        {
            line new_line = {(i-1), cost[i]};
            for(;cht.size()>=2;)
            {
                line last=cht.back();
                line stolast=cht[cht.size()-2];
                int x=cross(last,stolast);
                int x1=x-1,x2=x+1;
                if(min(stolast.eval(x), new_line.eval(x))<=last.eval(x))
                    if(min(stolast.eval(x1), new_line.eval(x1))<=last.eval(x1))
                        if(min(stolast.eval(x2), new_line.eval(x2))<=last.eval(x2))
                        {
                            cht.pop_back();
                        }
                        else break;
                    else break;
                else break;
            }
            cht.push_back(new_line);
        }
    }
    /*cout<<"CHT:\n";
    for(int i=0;i<cht.size();i++)
    {
        cout<<cht[i].a<<" "<<cht[i].b<<endl;
    }*/
    vector<pair<ll,ll> >alo;
    for(int i=0;i<q;i++)
    {
        alo.push_back({ps[i],i});
    }
    sort(alo.rbegin(),alo.rend());
    int ptr=0;
    for(int i=0;i<alo.size();i++)
    {
        ans[alo[i].second]=cht[ptr].eval(alo[i].first);
        while(ptr+1<cht.size()&&cht[ptr+1].eval(alo[i].first)<ans[alo[i].second])
        {
            ptr++;
            ans[alo[i].second]=cht[ptr].eval(alo[i].first);
        }
    }
}
void print()
{
    for(int i=0;i<q;i++)
    {
        cout<<ans[i]<<endl;
    }
}
void solve()
{
    read();
    t=0;
    dfs(1,0);
    for(int i=1;i<=n;i++)
    {
        arr[time_in[i]]=dep[i];
        what[time_in[i]]=i;
    }
    ogi.build(1,n,1);
    mark[1]=1;
    cost[0]=2*sum_all;
    for(int num_fr=1;num_fr<=n-1;num_fr++)
    {
        pair<ll,ll> best = ogi.query(1,n,1,1,n);
        //cout<<"?\n";
        //cout<<best.first<<" "<<best.second<<endl;
        if(best.second==0)
        {
            cost[num_fr]=0;continue;
        }
        cost[num_fr]=cost[num_fr-1]-best.first;
        vector<int>path;
        path.push_back(what[best.second]);
        //cout<<"%\n";
        while(!mark[path.back()])
        {
            //cout<<path.back()<<endl;
            path.push_back(par[path.back()]);
        }
        //cout<<"^^\n";
        reverse(path.begin(),path.end());
        for(auto xd:path)
        {
            ll delta=dep[xd]-dep[par[xd]];
            mark[xd]=1;
            //cout<<"$$ "<<delta<<" "<<time_in[xd]<<" "<<time_out[xd]<<endl;
            ogi.update(1,n,1,time_in[xd],time_out[xd],-delta);
        }
    }
    solve_lines();
    print();
}
int main()
{
    /*ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);*/
    cin>>alo;
    while(alo--)
    {
        solve();
    }
return 0;
}

/*
2
7
1 2 1000000000
1 3 1000000000
2 4 1000000000
2 5 1000000000
3 6 1000000000
3 7 1000000000
2
10
1000000000

7
1 2 1000000000
1 3 1000000000
2 4 1000000000
2 5 1000000000
3 6 1000000000
3 7 1000000000
2
10
1000000000
*/
