#include <iostream>
#define endl '\n'
using namespace std;

const int MAXN = 1e7;
const int MOD = 1102024631;

int n;
long long m;
pair<int, int> pp;
int coeff = 1, coeff2 = 1;
long long ans, tmp = 1;
int mult[MAXN + 5], rev[MAXN + 5];

pair<int, int> modpow(long long a, int b, int c)
{
    long long ret1 = 1, ret2 = 1;
    unsigned int pw = 1;
    while (b >= pw)
    {
        if (b & pw) ret1 = 1ll * ret1 * a % MOD;
        if (c & pw) ret2 = 1ll * ret2 * a % MOD;
        a = a * a % MOD;
        pw <<= 1;
    }
    return {ret1, ret2};
}

int modpow2(long long a, int b)
{
    long long ret = 1;
    while (b)
    {
        if (b & 1) ret = ret * a % MOD;
        b >>= 1;
        a = a * a % MOD;
    }
    return ret;
}

int main()
{
    ios :: sync_with_stdio(false);
    cin.tie(NULL); cout.tie(NULL);

    ///cin >> m >> n;
    m %= (MOD - 1);
    n = 1e7;
    m = MOD - 2;

    for (int i = 1; i * 2 <= n; ++ i)
    {
        pp = modpow(i, MOD - 2, m);
        rev[i] = 1ll * pp.first * (n - i + 1) % MOD;
        mult[i] = pp.second;
    }

    for (int i = n / 2 + 1; i <= n; ++ i)
    {
        mult[i] = modpow2(i, m);
    }

    if (n > 1500000) return 0;

    if (n & 1) coeff2 = -1;
    ans = mult[n];
    for (int i = 1; 2 * i < n; ++ i)
    {
        coeff *= -1;
        coeff2 *= -1;
        tmp = tmp * rev[i] % MOD;
        ans = (ans + coeff * tmp * mult[n - i] % MOD) % MOD;
        ans = (ans + coeff2 * tmp * mult[i] % MOD) % MOD;
    }
    if (!(n & 1))
    {
        coeff *= -1;
        tmp = tmp * rev[n / 2] % MOD;
        ans = (ans + coeff * tmp * mult[n / 2] % MOD) % MOD;
    }
    ans = (ans + MOD) % MOD;
    cout << ans << endl;

    return 0;
}
