#include "gcd5.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <random>
#include <map>
#define endl '\n'
using namespace std;

const int INF = 1e9;

map<int, long long> mp;

long long query(int x);
void answer(long long a, long long b);

long long query2(int x)
{
    if (mp.count(x)) return mp[x];
    return mp[x] = query(x);
}

void solve(int n)
{
    long long y1 = query2(-INF);
    long long y2 = query2(-INF + 1);
    long long a = y2 - y1, b = y1 + INF * a;
    answer(a, b);
    n--;
    int l0 = -INF + 2, l, r, mid;
    while (n)
    {
        l = l0;
        r = INF;
        while (r - l > 1)
        {
            mid = (l + r) / 2;
            if (query2(mid) == 1ll * a * mid + b) l = mid;
            else r = mid;
        }
        a = query2(r + 1) - query2(r);
        b = query2(r) - r * a;
        answer(a, b);
        l = r + 2;
        n--;
    }
}
