#include "gcd5.h"
///#include "Lgrader.cpp"
#include <iostream>
#include <random>
#include <cmath>
#include <map>
#include <set>
#define endl '\n'
using namespace std;

const long long INF = 1e9;

int N;
map<long long, long long> mp;
set< pair<long long, long long> > s;

long long query(int x);
void answer(long long a, long long b);

void find_line(int x)
{
    long long y1 = query(x - 1), y2 = query(x), y3 = query(x + 1);
    if (y3 - y2 == y2 - y1)
    {
        long long a = y2 - y1;
        s.insert({a, y2 - a * x});
        answer(a, y2 - a * x);
        mp[a] = 1;
        N--;
    }
    else
    {
        long long y0 = query(x - 2);
        if (y2 - y1 == y1 - y0)
        {
            long long a = y2 - y1;
            s.insert({a, y2 - a * x});
            answer(a, y2 - a * x);
            N--;
        }
        else
        {
            long long a = y3 - y2;
            ///cout << a << " " << y3 - a * (x + 2) << endl;
            s.insert({a, y2 - a * x});
            answer(a, y2 - a * x);
            N--;
        }
    }
}

void solve(int n)
{
    N = n;
    long long y1 = query(-INF);
    long long y2 = query(-INF + 1);
    long long a = y2 - y1;
    long long b = y1 + INF * a;
    s.insert({a, b});
    mp[a] = 1;
    answer(a, b);
    ///cout << a << " " << b << endl;
    N--;

    if (N == 0) return;

    y1 = query(INF - 1);
    y2 = query(INF);
    a = y2 - y1;
    b = y2 - INF * a;
    s.insert({a, b});
    mp[a] = 1;
    answer(a, b);
    ///cout << a << " " << b << endl;
    N--;

    while (N)
    {
        auto it = s.begin();
        long long a1 = (*it).first, b1 = (*it).second;
        it++;
        long long a2 = (*it).first, b2 = (*it).second;
        long long x0 = (b1 - b2) / (a2 - a1);
        while (x0 * (a2 - a1) > b1 - b2) x0--;
        ///cout << a1 << " " << b1 << " " << a2 << " " << b2 << " " << x0 << " " << query(x0) << endl;
        if (query(x0) > a1 * x0 + b1) find_line(x0);
        else s.erase(s.begin());
    }
}
