#include<bits/stdc++.h>

#define MOD 1102024631
#define MAXN 7007
#define int long long

using namespace std;

long long n, m;
int dp[MAXN], comb[MAXN][MAXN], pows[MAXN];

void findComb(int i, int j)
{
    comb[i][j] = (comb[i - 1][j - 1] + comb[i - 1][j]) % MOD;
}
void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cin>>n>>m;
    pows[0] = 1;
    for(int i = 1; i <= n; i ++)
    {
        comb[i][1] = i;
        comb[i][0] = comb[i][i] = 1;
    }
    for(int j = 1; j <= m; j ++)
    {
        long long cur = 1;
        for(int i = 1; i <= n; i ++)
        {
            cur = (cur * j) % MOD;
        }
        pows[j] = cur;
    }
}
void solve()
{
    dp[1] = 1;
    pows[1] = m;
    for(int i = 2; i <= m; i ++)
    {
        //cout<<i<<" = I\n";
        dp[i] = (pows[i] - i) % MOD;
        if(dp[i] < 0) dp[i] += MOD;
        //cout<<pows[i]<<endl;
        for(int j = 2; j < i; j ++)
        {
            findComb(i, j);
            dp[i] -= comb[i][j] * dp[j];
            dp[i] %= MOD;
            if(dp[i] < 0) dp[i] += MOD;
        }
    }
    cout<<dp[m]<<endl;
}
signed main()
{
    read();
    if(n < m)
    {
        cout<<0<<endl;
        return 0;
    }
    solve();
    return 0;
}

