#include<bits/stdc++.h>
#include "gcd5.h"

#define INF 1999999998
#define HALFINF 1000000000

using namespace std;

struct Line
{
    long long a, b;
    Line(){}
    Line(long long yy1, long long yy2, long long x)
    {
        a = yy2 - yy1;
        b = yy1 - a * x;
    }
    long long operator() (long long x)
    {
        return a * x + b;
    }
    bool operator!= (Line other)
    {
        return a != other.a;
    }
};
int N;
mt19937 mt(chrono::high_resolution_clock::now().time_since_epoch().count());
vector<Line> lines;

pair<Line, bool> check(long long x, long long y)
{
    for(auto l : lines)
    {
        if(l(x) == y) return {l, 0};
    }
    return {Line(), 1};
}
pair<Line, bool> tries(int kk)
{
    long long xx1 = kk;
    long long y1 = query((int)xx1);
    auto chk = check(xx1, y1);
    if(chk.second)
    {
        long long xx2 = (long long)xx1 + 1;
        long long y2 = query((int)xx2);
        auto ch2 = check(xx2, y2);
        if(ch2.second == false) return ch2;
        long long d1 = y2 - y1;
        long long xx3 = (long long)xx2 + 1;
        long long y3 = query((int)xx3);
        long long d2 = y3 - y2;
        if(d2 == d1)
        {
            return {Line(y2, y3, xx2), 1};
        }
        else
        {
            auto chk3 = check(xx3, y3);
            if(chk3.second)
            {
                long long xx4 = (long long)xx3 + 1;
                long long y4 = query((int)xx4);
                long long d3 = y4 - y3;
                if(d3 == d2)
                {
                    return {Line(y3, y4, xx3), 1};
                }
                else
                {
                    return {Line(y1, y2, xx1), 1};
                }
            }
            else return {Line(y1, y2, xx1), 1};
        }
    }
    else return chk;
}
void rec(int l, int r)
{
    if(l >= r) return;
    auto f = tries(l);
    auto s = tries(r);
    //cout<<l<<" "<<r<<endl;
    //cout<<"Right line: "<<s.first.a<<", "<<s.first.b<<endl;
    //cout<<"Left line: "<<f.first.a<<", "<<f.first.b<<endl;
    if(!(f.first != s.first))
    {
        if(f.second) lines.push_back(f.first);
        return;
    }

    if(f.second) lines.push_back(f.first);
    if(s.second) lines.push_back(s.first);
    int mid = (l + r) / 2;
    rec(l, mid);
    rec(mid + 1, r);
}
void solve(int n)
{
    N = n;
    rec(-1e9, 1e9 - 3);
    for(auto l : lines)
    {
        answer(l.a, l.b);
        //cout<<l.a<<" "<<l.b<<endl;
    }
    //cout<<check(8, 3)<<endl;
}
/*
2
1 -5
-1 5

6
1 19
145415 8945
-516 1781
-81681 454
684 -7451
54 -8451

6
1 2
2 3
3 4
4 5
5 6
6 7
*/
