#include<bits/stdc++.h>
#include "gcd5.h"

#define INF 100000
#define HALFINF 50000

using namespace std;

struct Line
{
    long long a, b;
    Line(){}
    Line(long long yy1, long long yy2, long long x)
    {
        a = yy2 - yy1;
        b = yy1 - a * x;
    }
    long long operator() (long long x)
    {
        return a * x + b;
    }
    bool operator!= (Line other)
    {
        return a != other.a;
    }
};
int N;
mt19937 mt(chrono::high_resolution_clock::now().time_since_epoch().count());
vector<Line> lines;

bool check2(Line lll)
{
    for(auto l : lines)
    {
        if(!(l != lll)) return 0;
    }
    return 1;
}
Line tries()
{
    long long xx1 = (int)mt() % INF - HALFINF;
    long long y1 = query((int)xx1);
        long long xx2 = (long long)xx1 + 1;
        long long y2 = query((int)xx2);
        long long d1 = y2 - y1;
        long long xx3 = (long long)xx2 + 1;
        long long y3 = query((int)xx3);
        long long d2 = y3 - y2;
        if(d2 == d1)
        {
            return Line(y2, y3, xx2);
        }
        else
        {
                long long xx4 = (long long)xx3 + 1;
                long long y4 = query((int)xx4);
                long long d3 = y4 - y3;
                if(d3 == d2)
                {
                    return Line(y3, y4, xx3);
                }
                else
                {
                    return Line(y1, y2, xx1);
                }
        }
}
void solve(int n)
{
    N = n;
    while(lines.size() != n)
    {
        auto ch = tries();
        //cout<<ch.a<<" "<<ch.b<<endl;
        if(check2(ch))
        {
            lines.push_back(ch);
        }
    }
    for(auto l : lines)
    {
        answer(l.a, l.b);
        //cout<<l.a<<" "<<l.b<<endl;
    }
    //cout<<check(8, 3)<<endl;
}
/*
2
1 -5
-1 5

6
1 19
145415 8945
-516 1781
-81681 454
684 -7451
54 -8451

6
1 2
2 3
3 4
4 5
5 6
6 7
*/
