#include<bits/stdc++.h>
using namespace std;

const long long mod=1102024631;

long long n,m,ans;

long long power(long long a,long long b){
    if(b==0)return 1;
    if(b==1)return a;
    if(b==2)return (a*a)%mod;
    if(b%2==0)return power(power(a,b/2),2);
    return (power(power(a,b/2),2)*a)%mod;
}

long long fact[10000007];

long long comb(long long a,long long b){
    assert(a<=b);
    return (fact[b]*((power(a,mod-2)*power(b-a,mod-2))%mod))%mod;
}

long long dp[10000007];

int main(){

    cin>>m>>n;

    fact[0]=1;
    for(long long i=1;i<=n;i++){
        fact[i]=(fact[i-1]*i)%mod;
    }

    dp[1]=1;
    for(int i=2;i<=n;i++){
        for(int f=1;f<=i-1;f++){
            dp[i]+=(dp[f]*comb(i-f,i))%mod;
        }

        dp[i]%=mod;
        dp[i]=(power(i,m)-dp[i]+mod)%mod;
    }

    cout<<dp[n]<<"\n";
    
    return 0;
}