#include <bits/stdc++.h>
using namespace std;

template< class T, class T2 > inline bool chkmin( T&a, const T2& b ){ return a > b ? a = b, 1 : 0;}
template< class T, class T2 > inline bool chkmax( T&a, const T2& b ){ return a < b ? a = b, 1 : 0;}
#ifndef LOCAL
#define cerr if(false) cerr
#endif // LOCAL

#define out(x) #x << " = " << x << "  "

typedef long long ll;

const int MAX_N = 1e5 + 42;
const int mod = 1e9 + 7;


int dist[MAX_N];
int maxDist = 0;
void dfs( int x, const vector< vector< std::pair <int, int > > >& v, int par = -1 ){

    cerr << out( x ) << out( par ) << endl;
    chkmax( maxDist, dist[x] );

    for( auto j : v[x] ){
        //std::pair< int, int > j;
        //j.first = J;
        //j.second = 1;
        if( j.first == par ) continue;
        dist[j.first] = dist[x] + j.second;
        dfs( j.first, v,  x );
    }
}

int main (){

#ifndef LOCAL
std::ios_base::sync_with_stdio(false); std::cin.tie(NULL); std::cout.tie(NULL);
#endif // LOCAL


    int t;
    std::cin >> t;
    while( t-- ){

        int n;
        std::cin >> n;

        std::vector< std::vector< std::pair< int, int > > > v;
        v.resize( n );

        for( int i=0 ; i < n-1 ; i++ ){
            int a, b, c;
            std::cin >> a >> b >> c;
            a--; b--;
            //v[a].push_back( b );
            //v[b].push_back( a );
            v[a].push_back({b, c });
            v[b].push_back({a, c });
        }

        cerr << "anansko " << endl;


        dist[0] = 0;
        maxDist = 0;
        dfs( 0, v );

        cerr << out( maxDist ) << endl;

        int q;
        std::cin >> q;
        while( q-- ){
            int curr;
            std::cin >> curr;
        }

        std::cout << ( n-1 ) * 2 - 1 << endl;


    }


    return 0;
}
/*
1
7
1 2 1
2 3 1
3 4 1
4 5 1
2 6 1
1 7 1
*/
