#include <iostream>
using namespace std;
const int MAXN = 7 * 1e3 + 1;
const long long MOD = 1102024631;
long long fact[MAXN];
long long func[MAXN];
long long power(long long a, long long b) {
    if (b == 1) {
        return a;
    }
    if (b % 2 == 0) {
        long long ans = a * a % MOD;
        return power(ans, b / 2);
    }
    if (b % 2 == 1) {
        return (a * power((a * a) % MOD, b / 2)) % MOD;
    }
}
int main() {
    ios_base::sync_with_stdio(false);
    cin.tie(0);
    cout.tie(0);
    fact[0] = 1;
    for (long long curr = 1; curr <= MAXN; curr++) {
        fact[curr] = (fact[curr - 1] * curr) % MOD;
    }
    long long n, m;
    cin >> m >> n;
    if (n > m) {
        cout << 0;
        return 0;
    }
    func[1] = 1;
    for (long long curr = 2; curr <= n; curr++) {
        func[curr] = power(curr, m);
        for (long long now = 1; now < curr; now++) {
            long long tool = func[curr - now];
            long long comb = fact[curr];
            comb *= power(fact[now], MOD - 2);
            comb %= MOD;
            comb *= power(fact[curr - now], MOD - 2);
            comb %= MOD;
            tool *= comb;
            tool %= MOD;
            func[curr] -= tool;
//            func[curr] -= (func[curr - now] * (((fact[curr] * power(fact[curr - now], MOD - 2)) % MOD) * power(fact[now], MOD - 2) % MOD)) % MOD;
            while (func[curr] < 0) {
                func[curr] += MOD;
            }
        }
    }
    cout << func[n];
    return 0;
}
