#include "gcd5.h"
#include <algorithm>
#include <array>
#include <cmath>
#include <iostream>
#include <random>
#include <utility>
#include <vector>
#define MAXN 100'007
std::pair<long long, long long> getLine(int xx)
{
    //std::cout<<"tyrsq "<<xx<<"\n";
    long long yy1=query(xx);
    long long yy2=query(xx+1);
    long long a=yy2-yy1;
    long long b=yy1-a*xx;
    //std::cout<<a<<" "<<b<<"\n";
    return {a,b};
}
void solve(int n) {
    int lastx=-1'000'000'000;
    std::pair<long long, long long> prava=getLine(lastx);
    answer(prava.first,prava.second);
    for (int q=2;q<=n;q++)
    {
        int l=lastx+1,r=1'000'000'000;
        while (l<r-1)
        {
            int mid=(l+r)/2;
            long long yy=query(mid);
            if (prava.first*mid+prava.second==yy) l=mid;
            else r=mid;
        }
        lastx=l+1;
        prava=getLine(lastx);
        answer(prava.first,prava.second);
    }
}
