#include <iostream>
using namespace std;
const long long mod=1102024631;
const int MAXN=7e3+10;
long long comb[MAXN][MAXN], dp[MAXN][MAXN];
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    int n, m;
    cin >> m >> n;
    if (n>m) {
        cout << 0 << endl;
        return 0;
    }
    comb[1][0]=comb[1][1]=1;
    for (int i=2;i<=m;i++) {
        comb[i][0]=1;
        for (int j=1;j<=m;j++) {
            comb[i][j]=(comb[i-1][j-1]+comb[i-1][j])%mod;
        }
    }
    dp[0][0]=1;
    for (int i=1;i<=m;i++) {
        for (int j=1;j<=min(i,n);j++) {
            for (int k=1;i-k>=j-1;k++) {
                dp[i][j]=(dp[i][j]+dp[i-k][j-1]*comb[i][k])%mod;
            }
        }
    }
    cout << dp[m][n] << endl;
    return 0;
}
// 3 2
