#include <iostream>
#include <vector>
using namespace std;
//#define endl '\n'
const int MAXN=1e5+10;
const long long llinf=1e18;
vector <pair <int, long long> > v[MAXN];
pair <int, long long> par[MAXN], tree[4*MAXN];
long long ans[MAXN], dist[MAXN];
long long res, maxs;
int in[MAXN], maxin[MAXN], idx[MAXN], in_cnt;
bool vis[MAXN];
int maxi, brch;
int n;
void build_tree(int node, int l, int r) {
    if (l==r) {
        tree[node].first=dist[l];
        tree[node].second=idx[l];
        return;
    }
    int mid=(l+r)/2;
    build_tree(node*2,l,mid);
    build_tree(node*2+1,mid+1,r);
    if (tree[node*2].first>tree[node*2+1].first) tree[node]=tree[node*2];
    else tree[node]=tree[node*2+1];
}
void update(int node, int l, int r, int ql, int qr, long long ch) {
    if (ql>r || qr<l) return;
    if (l>=ql && r<=qr) {
        tree[node].first+=ch;
        return;
    }
    int mid=(l+r)/2;
    update(node*2,l,mid,ql,qr,ch);
    update(node*2+1,mid+1,r,ql,qr,ch);
    if (tree[node*2].first>tree[node*2+1].first) tree[node]=tree[node*2];
    else tree[node]=tree[node*2+1];
}
void find_ch(int x, int p, long long sum) {
    if (p!=-1 && v[x].size()==1) brch++;
    in[x]=maxin[x]=in_cnt;
    dist[in_cnt]=sum;
    idx[in_cnt]=x;
    in_cnt++;
    for (auto i:v[x]) {
        if (i.first==p) continue;
        par[i.first]={x,i.second};
        find_ch(i.first,x,sum+i.second);
        maxin[x]=max(maxin[x],in[i.first]);
    }
}
void find_best() {
    auto p=tree[1];
    maxs=p.first;
    maxi=p.second;
}
void update_tree(int x) {
    while (x!=1) {
        if (vis[x]) break;
        vis[x]=true;
        update(1,1,n,in[x],maxin[x],-par[x].second);
        x=par[x].first;
    }
}
int main () {
    ios::sync_with_stdio(false);
    cin.tie(nullptr);
    cout.tie(nullptr);
    int t, q;
    long long a, b, c;
    cin >> t;
    for (int test=0;test<t;test++) {
        cin >> n;
        res=0;
        for (int i=0;i<n-1;i++) {
            cin >> a >> b >> c;
            v[a].push_back({b,c});
            v[b].push_back({a,c});
            res+=2ll*c;
        }
        brch=0;
        in_cnt=1;
        find_ch(1,-1,0);
        build_tree(1,1,n);
        for (int i=0;i<brch;i++) {
            find_best();
            res-=maxs;
            ans[i]=res;
            update_tree(maxi);
            //cout << ans[i] << ' ' << maxs << ' ' << maxi << endl;
        }
        cin >> q;
        long long p;
        for (int i=0;i<q;i++) {
            cin >> p;
            if (n==1) {
                cout << 0 << endl;
                continue;
            }
            long long answer=llinf;
            for (long long j=0;j<brch;j++) {
                answer=min(answer,ans[j]+j*p);
            }
            cout << answer << endl;
        }
        for (int i=1;i<=n;i++) {
            if (!v[i].empty()) v[i].clear();
            vis[i]=false;
            par[i]={-1,-1};
        }
    }
    return 0;
}
/*
1
5
1 2 1000
1 3 1
3 4 3
3 5 4
1
4

1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100
*/
