#include <bits/stdc++.h>

#define MAX_N 7003
#define MAX_M 7003

int64_t dp[MAX_N][MAX_M];

#define MOD 1102024631

int64_t do_dp(int64_t n, int64_t m) {
	if (n == 0 && m == 0) return 1;
	if (n == 0 || m == 0) return 0;
	if (dp[n][m] != -1) return dp[n][m];
	return dp[n][m] = (n * do_dp(n, m-1) + do_dp(n-1, m-1)) % MOD;
}

int64_t fact(int64_t n) {
	int64_t ans = 1;

	for (int i = 2; i <= n; i += 1) {
		ans = (ans * i) % MOD;
	}

	return ans;
}

int main() {
	std::cin.tie(0);
	std::cout.tie(0);
	std::ios::sync_with_stdio(0);
	
	std::cerr << "naqalo\n";

	int64_t n;
	int64_t m;

	std::cin >> m >> n;

	memset(dp, -1, sizeof(dp));

	std::cout << (fact(n) * do_dp(n, m)) % MOD << '\n';
}