#include <bits/stdc++.h>

#define MAX_N 21
#define MAX_M 21

int64_t dp[MAX_N][MAX_M];

#define MOD 1102024631

int64_t fast_exp(int64_t b, int64_t e) {
	int64_t ans = 1;

	while (e) {
		if (e & 1) ans = (ans * b) % MOD;
		e >>= 1;
		b = (b * b) % MOD;
	}

	return ans;
}

int64_t fact(int64_t n) {
    int64_t ans = 1;

    for (int64_t i = 2; i <= n; i += 1) {
        ans = (ans * i) % MOD;
    }

    return ans;
}

int64_t inv(int64_t n) {
	return fast_exp(n, MOD-2);
}

int64_t do_dp(int64_t n, int64_t m) {
	return ((fact(m) * inv(fact(n)) % MOD) * inv(fact(m-n))) % MOD;

}

int main() {
	std::cin.tie(0);
	std::cout.tie(0);
	std::ios::sync_with_stdio(0);
    
	std::cerr << "naqalo\n";

	int64_t n;
	int64_t m;

	std::cin >> m >> n;

	memset(dp, -1, sizeof(dp));

	std::cout << (fact(n) * do_dp(n, m)) % MOD << '\n';
}