#include <bits/stdc++.h>
using namespace std;

const int maxn = 1e5+2;
int t, n, q, maxd;
int used[maxn];
vector <int> v[maxn];

void bfs(int ver)
{
    used[ver] = 1;
    queue <int> q ;
    q.push(ver);
    int e, nb, i, len;

    while (!q.empty())
    {
        e = q.front(); q.pop();
        len = (int)(v[e].size());
        for (i=0; i<len; ++i)
        {
            nb = v[e][i];
            if (!used[nb])
            {
                used[nb] = used[e] + 1;
                if (used[nb] > maxd)
                    maxd = used[nb];
                q.push(nb);
            }
        }
    }
}

void read()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);

    cin >> t ;
    vector <int> pom;
    int i, a, b, l;
    while (t)
    {
        cin >> n ;
        for (i=1; i<=n; ++i)
            v[i] = pom;
        for (i=1; i<n; ++i)
        {
            cin >> a >> b >> l ;
            v[a].push_back(b);
            v[b].push_back(a);
        }
        cin >> q >> q ;

        memset(used, 0, sizeof(used));
        maxd = 0;
        bfs(1);
        cout << ((n-1) * 2 - maxd + 1) << '\n' ;
        -- t;
    }
}

int main()
{
    read();
    return 0;
}

/*

2
9
1 2 1
2 4 1
2 5 1
1 3 1
3 6 1
3 7 1
6 8 1
6 9 1
1
1000000000
3
1 2 1
2 3 1
1
1000000000

*/