#include <bits/stdc++.h>
#define endl '\n'
#define MAXN 100016
using namespace std;

struct Edge
{
    long long e, w, nom;
};


vector<Edge> edges[MAXN];
long long p;
long long ans;


queue<long long> q;
long long brNiva[MAXN];
long long allNiva=0;
bool used[MAXN];
void findBrNiva()
{
    brNiva[1] = 0;
    used[1] = true;
    q.push(1);
    allNiva = 0;
    while (!q.empty())
    {
        long long curr = q.front();
        q.pop();
        for (auto edge : edges[curr])
        {
            long long next = edge.e;
            if ( used[next] ) continue;
            used[next] = true;
            brNiva[next] = brNiva[curr] + 1;
            if ( brNiva[next] > allNiva ) allNiva = brNiva[next];
            q.push(next);
        }
    }
}
int main()
{
    ios::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);

    long long T;
    cin >> T;


    for (long long h=0; h<T; h++)
    {
        long long n;
        cin >> n;
        memset(brNiva, 0, sizeof(brNiva));
        allNiva = 0;
        for (long long i=1; i<=n; i++)
        {
            edges[i].clear();
        }
        for (long long j=0; j<n-1; j++)
        {
            long long a, b, l;
            cin >> a >> b >> l;
            edges[a].push_back({b, l, j});
            edges[b].push_back({a, l, j});
        }
        findBrNiva();
        long long Q;
        cin >> Q;
        for (long long g=0; g < Q; g++)
        {
            long long P;
            cin >> P;

            cout << ((n-1-allNiva)*2 + allNiva) << endl;
        }


    }
}
/**
1
7
1 2 10
1 3 10
2 4 5
2 5 10
3 6 10
3 7 20
2
10
100
---------------------
90
100

*/
