#include "gcd5.h"
#include<iostream>
#include<map>
using namespace std;
struct line
{
    long long m,c;
};
map<pair<long long,long long>,bool>lines;
long long intersect(line cur,line other)
{
    long long x=(other.c-cur.c)/(cur.m-other.m);
    return x;
}
line ask(long long x)
{
    long long val=query(x);
    if(x!=1e9)
    {
        long long val2=query(x+1);
        long long a=val2-val;
        long long b=val-a*x;
        if(b==val2-a*(x+1))
        {
            return {a,b};
        }
    }

    long long val2=query(x-1);
    long long a=val-val2;
    long long b=val-a*x;
    return {a,b};
}
bool check(line l)
{
    if(lines[{l.m,l.c}]==1)return 1;
    answer(l.m,l.c);
    //cout<<l.m<<" "<<l.c<<"\n";
    lines[{l.m,l.c}]=1;
    return 0;
}
void rec(line l,line r)
{
    if(l.m==r.m && l.c==r.c)return;
    long long x=intersect(l,r);

    line mid=ask(x);
    if(mid.m==l.m && mid.c==l.c)return;
    if(mid.m==r.m && mid.c==r.c)return;
    rec(l,mid);
    rec(mid,r);

    if(x+1<=1e9)
    {mid=ask(x+1);
    if(mid.m==l.m && mid.c==l.c)return;
    if(mid.m==r.m && mid.c==r.c)return;
    rec(l,mid);
    rec(mid,r);}

    if(x-1>=-1e9)
    {mid=ask(x-1);
    if(mid.m==l.m && mid.c==l.c)return;
    if(mid.m==r.m && mid.c==r.c)return;
    rec(l,mid);
    rec(mid,r);}
}
void solve(int n)
{
    line l=ask(-1e9);
    check(l);
    line r=ask(1e9);
    check(r);
    rec(l,r);
}
