#include<bits/stdc++.h>
using namespace std;

const long long MOD = 1102024631;
long long fact[1500001];
long long inv[1500001];

long long calc(long long a, long long b) {
    if(b == 0) {
        return 1;
    }
    long long ans = calc(a,b/2);
    ans*=ans;
    ans%=MOD;
    if(b%2) {
        ans*=a;
        ans%=MOD;
    }
    return ans;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);
    cout.tie(NULL);
    long long n,m;
    fact[0] = 1;
    for(long long i = 1; i <= 1500000; i++) {
        fact[i] = (fact[i-1]*i)%MOD;
    }
    for(long long i = 0; i <= 1500000; i++) {
        inv[i] = calc(fact[i],MOD-2);
    }
    cin >> m >> n;
    if(n > m) {
        cout << 0;
        return 0;
    }
    long long ans = 0;
    for(long long i = 0; i < n; i++) {
        long long c = (((fact[n]*inv[i])%MOD)*inv[n-i])%MOD;
        if(i%2 == 0) {
            ans+=c*calc(n-i,m);
        }
        else {
            ans-=c*calc(n-i,m);
        }
        ans+=MOD*MOD;
        ans%=MOD;
    }
    cout << ans;
    return 0;
}
