#include <bits/stdc++.h>

using namespace std;

const int maxn = 7005;
const long long mod = 1102024631;

int n, m;

long long dp[maxn][maxn];

void fastIO()
{
    ios_base::sync_with_stdio(0);
    cin.tie(0);
    cout.tie(0);
}

int main()
{
    fastIO();

    cin >> m >> n;

    for (int i = 0; i <= m; ++i)
    {
        dp[0][i] = 1;
    }

    for (int i = 1; i <= n; ++i)
    {
        for (int j = 1; j <= m; ++j)
        {
            dp[i][j] = ((1LL * j) * dp[i - 1][j - 1]) % mod;
        }
    }

    cout << dp[n][m] << endl;

    return 0;
}
