#include <bits/stdc++.h>
using namespace std;
vector<pair<int,long long>> edges[1003][50];
vector<pair<int,pair<long long,long long>>> edges2[1003][50];

long long friends[1003];

long long super_weights[1003][50];

long long ans=0;
int P=0;

long long weight_hinter(int a,long long w,int par,int T)
{
    for(auto child : edges[a][T])
    {
        if(child.first==par)continue;
        long long chW=weight_hinter(child.first,child.second,a,T);
        super_weights[a][T]+=chW;

        edges2[a][T].push_back({child.first,{chW,child.second}});
    }
    super_weights[a][T]+=w;

    return super_weights[a][T];
}

long long solve(int node,long long w,int par,int T)
{
    long long returned_w=0;
    for(auto child : edges2[node][T])
    {
        if(child.first==par)continue;
        ans+=child.second.second;
        ans+=min(returned_w,P);
        returned_w=solve(child.first,child.second.second,node,T);
    }
    return w+returned_w;
}

bool func(pair<int,pair<long long,long long>>a ,pair<int,pair<long long,long long>> b )
{
    return a.second.first<b.second.first;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(NULL);

    int n=0;
    int t;
    cin>>t;
    for(int T=0;T<t;T++)
    {
        ans=0;

        cin>>n;

        for(int i=0;i<n-1;i++)
        {
            long long a,b,w;
            cin>>a>>b>>w;
            edges[a][T].push_back({b,w});
            edges[b][T].push_back({a,w});
        }

        weight_hinter(1,0,-1,T);
        for(int i=1;i<=n;i++)
        {
            if(edges2[i][T].size()>0)
                sort(edges2[i][T].begin(),edges2[i][T].end(),func);
            //cout<<super_weights[i+1]<<endl;
            //for(auto child : edges2[i][T])
            //{
             //   cout<<i<<" "<<child.first<<" "<<child.second.first<<" "<<child.second.second<<endl;
            //}

        }

    }
    int p;
    cin>>p;
    for(int i=0;i<p;i++)
        cin>>friends[i];

    for(int T=0;T<t;T++)
    {
        for(int j=0;j<p;j++)
        {
            ans=0;
            P=friends[j];
            solve(1,0,-1,T);
            cout<<ans<<"\n";
        }
    }

    return 0;
}
