#include<bits/stdc++.h>
#include "gcd5.h"
using namespace std;
struct gap{
    long long xl;//x rounded left
    long long xr;//x rounded right
    long long ll;//left line index
    long long rl;//right line index
    long long lh;//left x min height
    long long rh;//right x min height
};
vector<pair<long long, long long>> lines;
stack<gap> gaps;
int ans=2;
gap cross(long long a1,long long b1,long long ll,long long a2,long long b2,long long rl){
    //cout<<"crossing ";
    long long a=a1-a2;
    long long b=b2-b1;
    gap g;
    g.xl=b/a;
    g.xr=g.xl;
    if(b%a>0)g.xr++;
    g.ll=ll;
    g.rl=rl;
    g.lh=g.xl*a1+b1;
    g.rh=g.xr*a2+b2;
    //cout<<"ok :)"<<endl;
    return g;
}
bool adj(long long x1,long long y1,long long x2,long long y2,long long x3,long long y3){
    if((y2-y1)/(x2-x1)==(y3-y2)/(x3-x2))return true;
    return false;
}
int line(long long x1,long long y1,long long x2,long long y2){
    long long a=(y2-y1)/(x2-x1);
    long long b=y1-x1*a;
    for(int i=0;i<lines.size();i++){
        if(a==lines[i].first&&b==lines[i].second){
            return i;
        }
    }
    lines.push_back({a,b});
    answer(a,b);
    ans++;
    return lines.size()-1;
}
void solve(int n) {
    long long y,y1,y2,y3,a;
    y1=query(-999999999);
    y2=query(-999999998);
    a=y2-y1;
    y=y1+999999999*a;
    lines.push_back({a,y});
    answer(a,y);
    if(n==1)return;
    y1=query(999999999);
    y2=query(999999998);
    a=y1-y2;
    y=y1-999999999*a;
    lines.push_back({a,y});
    answer(a,y);
    if(n==2)return;
    gaps.push(cross(lines[0].first,lines[0].second,0,lines[1].first,lines[1].second,1));
    while(ans<n){
        gap g=gaps.top();
        gaps.pop();
        //cout<<"checking gap..."<<endl;
        y1=query(g.xl);
        if(g.xl==g.xr&&y1==g.lh)continue;
        if(g.xl!=g.xr){
            //cout<<"split intersection..."<<endl;
            y2=query(g.xr);
            if(g.lh==y1&&g.rh==y2)continue;
            if(y2!=g.rh){
                //cout<<"new line?"<<endl;
                y3=query(g.xr+1);
                if(adj(g.xl,y1,g.xr,y2,g.xr+1,y3)){
                    //cout<<"perfect line"<<endl;
                    int nl=line(g.xl,y1,g.xr,y2);
                    //cout<<"line made?"<<endl;
                    gap ngl=cross(lines[g.ll].first,lines[g.ll].second,g.ll,lines[nl].first,lines[nl].second,nl);
                    gaps.push(ngl);
                    gap ngr=cross(lines[nl].first,lines[nl].second,nl,lines[g.rl].first,lines[g.rl].second,g.rl);
                    gaps.push(ngr);
                    continue;
                }
                else{
                    //cout<<"split line"<<endl;
                    int nll=line(g.xl,y1,g.xr,y2);
                    int nlr=line(g.xr,y2,g.xr+1,y3);
                    gap ngl=cross(lines[g.ll].first,lines[g.ll].second,g.ll,lines[nll].first,lines[nll].second,nll);
                    gaps.push(ngl);
                    gap ngr=cross(lines[nlr].first,lines[nlr].second,nlr,lines[g.rl].first,lines[g.rl].second,g.rl);
                    gaps.push(ngr);
                    continue;
                }
            }
        }
        else{
            //cout<<"perfect intersection...";
            y2=query(g.xl-1);
            y3=query(g.xl+1);
            if(adj(g.xl,y1,g.xl-1,y2,g.xl+1,y3)){
                //cout<<"perfect line"<<endl;
                int nl=line(g.xl,y1,g.xl+1,y3);
                //cout<<"line made?"<<endl;
                gap ngl=cross(lines[g.ll].first,lines[g.ll].second,g.ll,lines[nl].first,lines[nl].second,nl);
                gaps.push(ngl);
                gap ngr=cross(lines[nl].first,lines[nl].second,nl,lines[g.rl].first,lines[g.rl].second,g.rl);
                gaps.push(ngr);
                continue;
            }
            else{
//cout<<"split line"<<endl;
                int nll=line(g.xl-1,y2,g.xl,y1);
                int nlr=line(g.xl,y1,g.xl+1,y3);
                gap ngl=cross(lines[g.ll].first,lines[g.ll].second,g.ll,lines[nll].first,lines[nll].second,nll);
                gaps.push(ngl);
                gap ngr=cross(lines[nlr].first,lines[nlr].second,nlr,lines[g.rl].first,lines[g.rl].second,g.rl);
                gaps.push(ngr);
                continue;
            }
        }
    }
}
