#include <bits/stdc++.h>
#define endl '\n'
using namespace std;

const int64_t MOD = 1102024631;
const int64_t MAXM = 1e5 + 5000;
int64_t n, m;

unordered_map <bitset<MAXM>, int64_t> dp[MAXM];


int64_t solve(int pos, bitset <MAXM> mask)
{
    //cout << pos << " " << mask[1] << mask[2] << mask[3] << mask[4] << endl;
    if (pos == n)
    {

        //cout << (mask | (1>>1)) << endl;
        return (mask.count() == m);
    }

    if (dp[pos].find(mask) != dp[pos].end())
        return dp[pos][mask];

    int64_t ans = 0;
    bitset <MAXM> newMask = mask;
    for (int64_t i = 1; i <= m; i++)
    {
        newMask[i] = 1;
        //cout << "NEW: " << pos << " " << i << ", mask = " << newMask[1] << newMask[2] << newMask[3] << newMask[4]<< endl;

        ans = (ans + solve(pos+1, newMask))%MOD;

        newMask[i] = mask[i];
    }

    dp[pos][mask] = ans;
    return ans;
}
int main()
{
    //ios::sync_with_stdio(false);
    //cin.tie(0); cout.tie(0);

    int64_t ans = 0;
    cin >> n >> m;

    bitset <MAXM> b;
    cout << solve(0, b) << endl;

    return 0;
}
