#include <bits/stdc++.h>

#include "gcd5.h"

using namespace std;

const int64_t MIN = -1e9;
const int64_t MAX = 1e9;

set <pair <int64_t, int64_t>> lines;
void ans(int64_t l, int64_t r, int64_t a, int64_t b, bool direction)
{
    if (l > r)
        return;

    if (l < MIN || r > MAX)
        return;

    int64_t x1 = (l+r)/2;
    int64_t x2 = x1+1;

    if (x1 < MIN || x1 > MAX || x2 < MIN || x2 > MAX)
        return;

    int64_t y1 = query(x1);
    int64_t y2 = query(x2);

    int64_t new_a = (y2-y1)/(x2-x1);
    int64_t new_b = y1 - new_a*x1;

    if (new_a == a)
    {
        if (direction == 0)
        {
            ans(x2+1, r, new_a, new_b, 0);
        }
        else
        {
            ans(l, x1-1, new_a, new_b, 1);
        }
    }

    else
    {
        lines.insert({new_a, new_b});

        ans(x2+1, r, new_a, new_b, 0);
        ans(l, x1-1, new_a, new_b, 1);
    }

}
void solve(int n)
{


    int64_t x1 = MIN;
    int64_t x2 = x1+1;

    int64_t y1 = query(x1);
    int64_t y2 = query(x2);

    int64_t a = (y2-y1)/(x2-x1);
    int64_t b = y1 - a*x1;

    lines.insert({a, b});

    ans(-1e9, 1e9, a, b, 0);

    for (pair <int64_t, int64_t> line:lines)
    {
        answer(line.first, line.second);
    }

}
