#include <bits/stdc++.h>

#include "gcd5.h"

using namespace std;

const int64_t MIN = -1e9;
const int64_t MAX = 1e9;

set <pair <int64_t, int64_t>> lines;
void ans(int64_t l, int64_t r, int64_t a, int64_t b, bool direction)
{
    if (l > r)
        return;

    if (l < MIN || r > MAX)
        return;

    int64_t x0 = (l+r)/2;
    int64_t y0 = query(x0);

    if (x0 < MIN || x0 > MAX)
        return;

    int64_t line_a, line_b;
    set <pair <int64_t, int64_t>> m;

    int64_t x2, y2;
    for (int64_t i = -2; i <= 2; i++)
    {
        if (i == 0)
            continue;

        int64_t xi = x0+i;

        if (xi < MIN || xi > MAX)
            continue;

        int64_t yi = query(xi);

        int64_t new_a = (yi-y0)/(xi-x0);
        int64_t new_b = y0 - new_a*x0;

        pair <int64_t, int64_t> line = make_pair(new_a, new_b);

        if (m.find(line) != m.end())
        {
            line_a = new_a;
            line_b = new_b;

            x2 = xi;
            y2 = yi;
            break;
        }
        m.insert(line);
    }


    int64_t new_a = line_a, new_b = line_b;

    int64_t x1 = x0, y1 = y0;

    if (x1 > x2)
    {
        swap(x1, x2);
        swap(y1, y2);
    }

    //cout << x1 << " " << x2 << endl;
    if (new_a == a)
    {
        if (direction == 0)
        {
            ans(x2+1, r, new_a, new_b, 0);
        }
        else
        {
            ans(l, x1-1, new_a, new_b, 1);
        }
    }

    else
    {
        lines.insert({new_a, new_b});

       // cout << "!" << new_a << " " << new_b << "-> " << "(" << x1 << ", " << y1 << ")" << " " << "(" << x2 << ", " << y2 << ")" << endl;
        ans(x2+1, r, new_a, new_b, 0);
        ans(l, x1-1, new_a, new_b, 1);
    }

}
void solve(int n)
{


    int64_t x1 = MIN;
    int64_t x2 = x1+1;

    int64_t y1 = query(x1);
    int64_t y2 = query(x2);

    int64_t a = (y2-y1)/(x2-x1);
    int64_t b = y1 - a*x1;

    lines.insert({a, b});

    ans(-1e9, 1e9, a, b, 0);

    for (pair <int64_t, int64_t> line:lines)
    {
        //cout << line.first << " " << line.second << endl;
        answer(line.first, line.second);
    }

}
