#include <bits/stdc++.h>
#define endl "\n"

using namespace std;

const long long mod = 1102024631;
const int maxn = 1500000;

long long m,n;
long long fact[maxn];

void read()
{
    cin >> m >> n;
    fact[0] = 1;
    for(int i=1;i<=n;i++) fact[i] = (fact[i-1]*i)%mod;
}

long long step(long long a, long long b)
{
    long long res = 1;
    while(b>0)
    {
        if(b%2==1) res = (res*a)%mod;
        a = (a*a)%mod;
        b /= 2;
    }
    return res;
}

long long comb(long long x, long long y)
{
    long long ch = fact[x];
    long long zn = (fact[y]*fact[x-y])%mod;
    return (ch*step(zn,mod-2))%mod;
}

void solve()
{
    long long ans = 0;
    ans += step(n,m);
    for(int i=1;i<n;i++)
    {
        if(i%2==1)
        {
            ans -= (step(n-i,m)*comb(n,i))%mod;
            if(ans<0) ans += mod;
        }
        else
        {
            ans += (step(n-i,m)*comb(n,i))%mod;
            ans %= mod;
        }
    }
    cout << ans << endl;
}

int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    read();
    solve();
    return 0;
}
