#include <bits/stdc++.h>
#define endl "\n"
using namespace std;

const int maxn = 1e5+5;

struct edge
{
    long long ver,dist;
    edge(){};
    edge(int vi, long long di)
    {
        ver = vi;
        dist = di;
    }
};

long long t,n,q;
long long p[maxn];

vector<edge>g[maxn];
pair<int,int> sp[maxn];
long long st[maxn];

long long coin;
long long ans = 0;

long long dp[maxn][2];

void pre()
{
    for(int i=1;i<=n;i++) g[i].clear();
}

void dfs(int beg, int par)
{
    long long oferta = 0;
    for(edge nb:g[beg])
    {
        if(nb.ver!=par)
        {
            dfs(nb.ver,beg);
            long long ch = min(dp[nb.ver][0]+2*nb.dist,dp[nb.ver][1]+coin+nb.dist);
            dp[beg][0] += ch;
            ch -= (dp[nb.ver][1]+nb.dist);
            oferta = max(oferta,ch);
        }
    }
    dp[beg][1] = dp[beg][0];
    dp[beg][1] -= oferta;
}

void solve()
{
    dfs(1,1);
    cout << dp[1][1] << endl;
}

void read()
{
    cin >> n;
    pre();
    int x,y,d;
    for(int i=1;i<n;i++)
    {
        cin >> x >> y >> d;
        sp[i] = {x,y};
        st[i] = d;
        g[x].push_back({y,d});
        g[y].push_back({x,d});
    }
    cin >> q;
    for(int i=1;i<=q;i++)
    {
        for(int j=1;j<=n;j++) dp[j][0] = dp[j][1] = 0;
        cin >> p[i];
        coin = p[i];
        solve();
    }
}
int main()
{
    ios_base::sync_with_stdio(false);
    cin.tie(nullptr);
    cin >> t;
    for(int i=1;i<=t;i++) read();
    return 0;
}
